

/*创建日期*/
var callbackFunc = null;
var sel_screen_day_id = 0;
/*
func  回调函数
sch_list 月份日程数据，或者月份天数的数值
type 0 没有小红点，反之则有
*/
function createDate(func,sch_list){
	callbackFunc = func;
	var date_length = 0;
	var type = 0;
	if(typeof sch_list=='number' || sch_list.constructor==Number){
		date_length = sch_list;
	}else{
		type = 1;
		date_length = sch_list.length;
	}
	if(!$api.byId('month_element')){
		var div = document.createElement("DIV");
		var divbg = document.createElement("DIV");
		var divbox = document.createElement("DIV");
		var clearbtn = document.createElement("DIV");
		var closebtn = document.createElement("DIV");
		var confirmbtn = document.createElement("DIV");
		var totay = new Date().getDate();
		for(var i=0;i<date_length;i++){
			var d = i+1;
			var dayEl = document.createElement('DIV');
			dayEl.id = 'day'+d;
			dayEl.className = 'day';
			if(totay == d){
				dayEl.className = 'day today';
			}
			if(d >= totay){
				dayEl.onclick=function(){sel_screen_day(this)};
			}else{
				dayEl.className = 'day notday';
			}
			dayEl.setAttribute('data',d);
			var iconEl = '';
			if(type == 1)
			iconEl = sch_list[i].sch_list.length==0?'':'<i></i>';
			dayEl.innerHTML = d+iconEl;
			divbox.appendChild(dayEl);
		}
		div.id = 'month_element';
		div.style.position = "fixed";
		div.style.top = '0';
		div.style.left = '0';
		div.style.zIndex = '9';
		div.style.width = '100%';
		div.style.height = '100vh';
		div.style.background = 'rgba(0,0,0,0.5)';
		divbg.style.position = "relative";
		divbg.style.width = '100%';
		divbg.style.height = '100vh';
		divbox.style.position = "absolute";
		divbox.style.top = 'calc((100vh - 85vw) / 2)';
		divbox.style.left = '6vw';
		divbox.style.width = "88vw";
		divbox.style.height = "82vw";
		divbox.style.backgroundColor = '#fff';
		divbox.style.borderRadius = '10px';
		divbox.style.overflow = 'hidden';

		clearbtn.className = 'clearbtn';
		clearbtn.onclick=clear_sel;
		clearbtn.innerHTML = '清除选择';
		closebtn.className = 'closebtn';
		closebtn.onclick=close_month;
		closebtn.innerHTML = '取消';
		confirmbtn.className = 'confirmbtn';
		confirmbtn.onclick=confirm_month;
		confirmbtn.innerHTML = '确定';

		divbox.appendChild(clearbtn);
		divbox.appendChild(closebtn);
		divbox.appendChild(confirmbtn);
		divbg.appendChild(divbox);
		div.appendChild(divbg);
		document.body.appendChild(div);
	}else{
		$api.byId('month_element').style.display = 'block';
	}
}
function sel_screen_day(obj){
	if(sel_screen_day_id > 0)
		$api.byId('day'+sel_screen_day_id).classList.remove('sel_day');
	$api.byId('day'+obj.getAttribute('data')).classList.add('sel_day');
	sel_screen_day_id = obj.getAttribute('data');
}
function clear_sel(){
	if(sel_screen_day_id==0)return;
	$api.byId('day'+sel_screen_day_id).classList.remove('sel_day');
	sel_screen_day_id = 0;
	callbackFunc("0");
}
function close_month(){
	$api.byId('month_element').style.display = 'none';
}
function confirm_month(){
	if(sel_screen_day_id==0){
		$api.byId('month_element').style.display = 'none';
	}else{
		callbackFunc(sel_screen_day_id);
		$api.byId('month_element').style.display = 'none';
	}
}
/*当月天数*/
function mGetDate(){
     var date = new Date();
     var year = date.getFullYear();
     var month = date.getMonth()+1;
     var d = new Date(year, month, 0);
     return d.getDate();
}