
function loop_echart(el,clr,data){
var mycharts = echarts.init($api.byId(el));
var option = {
    title:{
     	show:false,
     	text:""
	},
    tooltip: {
        trigger: '',
        show:false
    },
    series: [
        {
            name:'',
            type:'pie',
            radius: ['80%', '95%'],
            avoidLabelOverlap: true,
            itemStyle:{
            	normal:{
            		color:function(params) {
                        var colorList = clr;
                        return colorList[params.dataIndex]
                    }
            	}
            },
            labelLine:{
            	show:false
            },
            data:data
        }
    ]
 };
 mycharts.setOption(option);
 mycharts.on("click",function(params){

 })
}


function pie_echart(el,clr,data){
var mycharts = echarts.init($api.byId(el));
var option = {
    title:{
        show:false,
        text:""
    },
    tooltip: {
        trigger: '',
        show:true
    },
    series: [
        {
            name:'',
            type:'pie',
            selectedMode: 'single',
            avoidLabelOverlap: true,
            itemStyle:{
                normal:{
                    color:function(params) {
                        var colorList = clr;
                        return colorList[params.dataIndex]
                    }
                }
            },
            label:{
                normal: {
                    position : 'inner',
                    distance : 0.1
                }
            },
            labelLine:{
                normal: {
                    show: false
                }
            },
            data:data
        }
    ]
 };
 mycharts.setOption(option);
 mycharts.on("click",function(params){

 })
}