
var headerH = null;

var askParam = {};

var askItemList = [];

var nowPage = 0;//当前题目index
var nowPageId = 0;//题目id
var nowItemList = [];

var questionStatus = 0;


apiready=function()
{
	$api.fixedHeader();

  var headerE = document.getElementsByClassName("header")[0];

  headerH = $api.offset(headerE);

	init();

}
if(window.app_type=="WEB"){
init();
}

function init(){
  $api.byId('back_page').onclick=function(){
    $api.close();
  };

  if(window.app_type=="APP"){
      var bodyH = document.body.offsetHeight;
      var mainH = bodyH - headerH.h;
      $api.byId("main").style.top = headerH.h+"px";
      $api.byId("main").style.height = mainH+"px";
  }

  var data = $api.getPageParam("data");
  if(data == "" || data == "undefined"){
    return false;
  }else{
    askParam = JSON.parse(data);
		if(askParam.do_status > 0 || askParam.out_status == 2){
			questionStatus = 1;
		}
  }

  window.HostURL = window.WebURL;

  getAskListItem(askParam.id);

}

function getAskListItem(id){
  $api.send('api/sp/get_question_item_list/',"post",{question_id:id},function(data){
    // console.log(JSON.stringify(data))
    if(data.code == 0){
      $api.error(data.error_msg);
    }else{

      askItemList = data.list;

			mulu();

    }
  },true);
}

// 创建题目UI
function applySubject(index){

	nowPage = index;
	nowPageId = askItemList[index].info.id;
	nowItemList = [];

	var pre_btn = document.getElementsByClassName("prepage")[0];
	var next_btn = document.getElementsByClassName("nextpage")[0];
	var complete_btn = document.getElementsByClassName("complete")[0];
	pre_btn.classList.remove("ligth_btn");
	next_btn.classList.remove("ligth_btn");

	complete_btn.style.display="none";
	next_btn.style.display="block";
	pre_btn.style.display="block";

	if(index == 0){
		pre_btn.classList.remove("ligth_btn");
		next_btn.classList.add("ligth_btn");
	}else	if(index > 0 && index < askItemList.length - 1){
			pre_btn.classList.add("ligth_btn");
			next_btn.classList.add("ligth_btn");
	}else if(index == askItemList.length - 1){
			pre_btn.classList.add("ligth_btn");
			next_btn.classList.remove("ligth_btn");
			next_btn.style.display="none";
			if(questionStatus == 0){
				complete_btn.style.display="block";
				complete_btn.classList.add("ligth_btn");
			}
	}

	var data = askItemList[index];

	var askitemType = '';
	switch (data.info.question_type) {
		case 1:
			askitemType = '(单选)';
		break;
		case 2:
			askitemType = '(多选)';
		break;
	}

	//当前所在题目 标题
	$api.byId("askitem_title").innerText = (index+1)+'、'+data.info.question_info+askitemType;

	//当前所在题目  index
	document.getElementsByClassName("paging")[0].innerText = (index+1)+'/'+askItemList.length;

	//遍历题目选项
	var list_element = $api.byId("askitem_list");
	list_element.innerHTML = '';
	for(var i=0;i<data.item_list.length;i++){
			var ele = createAskItem(data.item_list[i],data.info.question_type,data.info.question_id);
			list_element.appendChild(ele);
	}
}
//创建题目选项 UI
function createAskItem(data,type,askitem_id){
		var lable = document.createElement("LABEL");
		lable.className = "list_option";

		var sele_style = "";
		if(data.status > 0){
					sele_style = "select_list_item";
		}
		if(data.status > 0 && questionStatus == 0){
				nowItemList.push(data.id);
		}

		lable.innerHTML = "<div id='item"+askitem_id+data.id+"' class='"+sele_style+"' data='"+data.id+"' data-status='"+data.status+"' data-type='"+type+"' data-sid='"+askitem_id+"' onclick='selectAskItem(this)'>"+data.item+"</div>";
		return lable;
}

//选择题目选项
function selectAskItem(obj){
		if(questionStatus == 1){
			if(askParam.out_status == 2)
				$api.tips("当前问卷调查已关闭！");
			else
				$api.tips("您已完成答卷，不能重新答卷！");
			return;
		}
		var type = obj.getAttribute("data-type");
		var status = obj.getAttribute("data-status");
		var sid = obj.getAttribute("data-sid");
		var item_list_id = obj.getAttribute("data");
		if(type == '1'){
				if(nowItemList.length > 0)
				$api.byId("item"+sid+""+nowItemList[0]).className = '';
				nowItemList = [];
				nowItemList.push(parseInt(item_list_id));
				obj.className = "select_list_item";
		}else{
				var b = false;
				for(var i=0;i<nowItemList.length;i++){
					if(nowItemList[i] == parseInt(item_list_id)){
						nowItemList.splice(i,1);
						b = true;
						break;
					}
				}
				if(b){
					obj.className = "";
				}else{
					nowItemList.push(parseInt(item_list_id));
					obj.className = "select_list_item";
				}
		}
}

// 上一页
function preQuestion(){
		if(nowPage > 0){
			nowPage--;
			applySubject(nowPage);
		}
}

// 下一页
function nextQuestion(){
	if(nowItemList.length == 0){
		nowPage++;
		applySubject(nowPage);
		return;
	}else{
		if(nowPage == (askItemList.length-1))return;
	}
	$api.send("api/sp/question_answer/","post",{detail_id:nowPageId,item_list:JSON.stringify(nowItemList)},function(data){
		  if(data.code == 0){
		    $api.error(data.error_msg);
		  }else{
				changeItemList();
		  }
	},true);
}
function changeItemList(){

		askItemList[nowPage].info.status = 1;

		for(var i=0;i<askItemList[nowPage].item_list.length;i++){
				askItemList[nowPage].item_list[i].status = 0;
		}

		for(var j=0;j<nowItemList.length;j++){
				for(var i=0;i<askItemList[nowPage].item_list.length;i++){
					if(askItemList[nowPage].item_list[i].id == nowItemList[j]){
						askItemList[nowPage].item_list[i].status = 1;
						break;
					}
				}
		}
		nowPage++;
		$api.byId("mulu"+nowPage).className = "gray_mulu";
		applySubject(nowPage);
}

function submitCheck(){
	if(questionStatus == 1){
		if(askParam.out_status == 2)
			$api.tips("当前问卷调查已关闭！");
		else
			$api.tips("您已完成答卷，不能重新答卷！");
		return;
	}
		var b = false;
		var on_do = [];
		for(var i=0;i<askItemList.length;i++){
				if(askItemList[i].info.status == 0){
					b = true;
					on_do.push(i);
					break;
				}
		}
		if(b){
					var endindex = askItemList.length-1;
				 if(on_do[0] == endindex){
						nextQuestion2();
				}else{
						$api.tips("您有未答的题，请完成答题！");
				}
		}else{
			nextQuestion2();
		}
}
// 下一页2
function nextQuestion2(){
	if(askParam.do_status == 1)return;
	if(nowItemList.length == 0){
		$api.tips("请选择答题选项！");
		return;
	}
	$api.send("api/sp/question_answer/","post",{detail_id:nowPageId,item_list:JSON.stringify(nowItemList)},function(data){
		  if(data.code == 0){
		    $api.error(data.error_msg);
		  }else{
				nowPage++;
				$api.byId("mulu"+nowPage).className = "gray_mulu";
				submitQuestion();
		  }
	},true);
}

// 完成答卷
function submitQuestion(){
  	$api.send("api/sp/question_submit/","post",{question_id:askParam.id},function(data){
      if(data.code == 0){
        app.error(data.error_msg);
      }else{
					questionStatus = 1;
        	askParam.do_status = 1;
					$api.tips("您已完成答卷！");
      }
    })
  }


// 目录
function mulu(){

		var no_status_page = 0;
    for(var i=0;i<askItemList.length;i++){
        var lable = document.createElement("LABEL");
				lable.className = "mulu_item";
				var itemindex = i+1;

				askItemList[i].info.status = 0;

				var b= false;
				var status = "";
				for(var j=0;j<askItemList[i].item_list.length;j++){
					var item = askItemList[i].item_list[j];
					if(item.status > 0){
						b= true;
						break;
					}
				}
				if(b){
					status = "gray_mulu";
					askItemList[i].info.status = 1;
				}else{
					if(no_status_page == 0){
							no_status_page = 1;
							nowPage = i;
					}
				}

				lable.innerHTML = "<div class='"+status+"' id='mulu"+itemindex+"' data='"+i+"' onclick='selectMulu(this)'>"+itemindex+'、'+askItemList[i].info.question_info+"</div>";
        $api.byId('mulu_list').appendChild(lable);
    }

		applySubject(nowPage);
}


// 选择题目
function selectMulu(obj){
	var index = parseInt(obj.getAttribute("data"));
	applySubject(index);
	hideMulu();
}
// 显示目录
function showMulu(){
	document.getElementsByClassName("mulu_wrap")[0].style.display = "block";
}
// 隐藏目录
function hideMulu(){
	document.getElementsByClassName("mulu_wrap")[0].style.display = "none";
}


















//[{"info":{"id":1,"question_id":1,"question_info":"您孩子的性别：","question_type":1},"item_list":[{"id":1,"detail_id":1,"item":"男","status":0},{"id":2,"detail_id":1,"item":"女","status":0}]},{"info":{"id":2,"question_id":1,"question_info":"您的孩子现在由谁看护？","question_type":2},"item_list":[{"id":3,"detail_id":2,"item":"父母","status":0},{"id":4,"detail_id":2,"item":"爷爷奶奶","status":0},{"id":5,"detail_id":2,"item":"姥姥姥爷","status":0},{"id":6,"detail_id":2,"item":"其他","status":0}]}]
//
