

var param = {};//

var question_index = 0;//当前题目的索引

var question_list = [];//所有题目的集合

var now_sel_inp = "";//当前点击的选项框

var now_child_id = 0;//孩子的id

var answer_data = [];//已提交答卷选择的答案

var now_answer_list = [];//当前答题中选择的答案选项

var now_sel_group = [];//当前选中的组

var screen_cross = 1;//1:横屏，2:竖屏

var line_group = [];


apiready=function(){

  $api.getStatusBar();

  setTimeout(function(){
      init();
  },500);

}
function setStatusBar(){
  $api.byId("wrap").style.paddingTop = window.headerPos.h+"px";
  $api.byId("mulu_box").style.marginTop = window.headerPos.h+"px";
  $api.byId("mulu_box").style.height = "calc(100vh - "+window.headerPos.h+"px)";
  $api.byId("results_wrap").style.top = window.headerPos.h+"px";
  $api.byId("results_wrap").style.height = "calc(100vh - "+window.headerPos.h+"px)";
}

if(window.app_type == "WEB"){
  window.onload = function(){
    init();
  }
}

function init(){
    // $api.byId("back_page").onclick=function(){
    //   $api.close();
    // }

    setStatusBar();


    var data = $api.getPageParam("data");
    now_child_id = parseInt($api.getPageParam("child_id"));

    if(data == "" || data == "undefined"){
        return;
    }else{
        param = JSON.parse(data);
    }

    if(parseInt(param.audio) > 0){
        var audio_url = window.HostURL+"api/resume_sys/get_paper_audio/"+$api.getToken()+'/?audio_id='+parseInt(param.audio);
        $api.byId('audiobox').setAttribute("src",audio_url);
        $api.byId('audiobox').addEventListener("canplaythrough",function(){
            $api.hideProgress();
        })
        $api.byId('audiobox').addEventListener("timeupdate",function(){
            $api.hideProgress();
        })

    }

    // $api.byId("page_title").innerText = param.bookname;
    $api.byId("paper_name").innerText = param.papername;
    $api.byId("question_title").innerText = param.papername;

    $api.byId("switch_screen").onclick = function(){
        if(screen_cross == 1){
            api.setScreenOrientation({
              orientation: 'portrait_up'
            });
            this.innerText = "切换横屏";
            screen_cross = 2;
        }else{
            api.setScreenOrientation({
              orientation: 'landscape_left'
            });
            this.innerText = "切换竖屏";
            screen_cross = 1;
        }
        // alert($api.byId("wrap").offsetWidth)
        setTimeout(function(){
          initContent();
          if(question_list.length > 0){
              createQuestion(question_list[question_index]);
          }
        },500)
    }

    $api.byId("content").onclick=function(){
      if($api.byId("serial"))
        $api.byId("serial").remove();
    }

    // createInput();
    getAnswer();

}

// do_answer child_id  answer_list[{answer_child  blank_id}]
// get_answer_child  paper_id  child_id

//获取题目答案
function getAnswer(){
    $api.send("api/resume_sys/get_answer_child/","post",{paper_id:param.id,child_id:now_child_id},function(data){
        // console.log(JSON.stringify(data));
        if(data.code == 0){
            $api.error(data.error_msg);
        }else{
            answer_data = data.list;
            get_paper_detail();
        }
    },false);
}

// 获取题目列表
function get_paper_detail(){
    $api.send("api/resume_sys/get_question_list/","post",{paper_id:param.id},function(data){
        // console.log(JSON.stringify(data));
        if(data.code == 0){
            $api.error(data.error_msg);
        }else{
            question_list = data.list;
            if(answer_data.length > 0){
                if(answer_data[0].status > 0){
                    checkError();
                    return;
                }
            }else{
                if(parseInt(param.audio) > 0){
                    $api.byId('audiobox').setAttribute("autoplay","autoplay");
                    $api.byId('audiobox').play();
                    $api.showProgress("听力录音加载中");
                }
            }

            api.setScreenOrientation({
              orientation: 'landscape_left'
            });

            setTimeout(function(){
                if(data.list.length > 0){
                    question_index = 0;
                    createQuestion(data.list[0]);
                }
            },500)

            createMulu();
        }
        setTimeout(function(){
            $api.hideProgress();
        },10000)
    },false);
}

// 创建题
function createQuestion(object){
    $api.byId('headline').innerHTML = object.title;
    if($("#headline img").length > 0){
        var imgname = window.ImgURL+'sub/img/'+$("#headline img").attr("src");
        $("#headline img").attr("src",imgname);
    }
    document.getElementsByClassName("paging")[0].innerText = (question_index+1)+'/'+question_list.length;
    $api.byId('questionpic').setAttribute('src',window.ImgURL+object.pic);
    $api.byId('questionpic').onload=function(){
        window.contentW = this.offsetWidth;

        if(object.type == 1){
            inputBox(object.blank_list,object.type);
        }
        if(object.type == 2){
            createCanvas(object.blank_list,object.type);
            // lineBox(object.blank_list,object.type);
        }
        if(object.type == 3){
            ringBox(object.blank_list,object.type);
        }
    }
}

/*******************************************************************创建圈一圈************************************************************************/
function ringBox(list,type){

  var boxEl = $api.byId("content");
  for(var i=0;i<list.length;i++){
    var el = null;
    if(list[i].blank_group != ""){
      el = createLineBox(list[i],type);
      boxEl.appendChild(el);
    }else{
      el = createInput(list[i]);
      boxEl.appendChild(el);
    }
  }
}

function createLineBox(object,type){
  var el_value = checkElAnswer(object.id);

  var div = document.createElement("DIV");

  if(el_value.status == 0){
      if(el_value.blank_id == "0" || el_value.blank_id == ""){
          div.className = "linesbox";
      }else{
          div.className = "linesbox linesbox2";
      }
      div.onclick=function(){
          selLinesBox(this);
      }
  }
  if(el_value.status == 1){
      if(el_value.baseanswer == "" || el_value.baseanswer == "0"){
          div.className = "linesbox";
      }else{
          div.className = "linesbox linesbox3";
      }
  }
  if(el_value.status == 2){
      if(el_value.baseanswer != "" && el_value.baseanswer != "0"){
          div.className = "linesbox linesbox3";
      }else{
          div.className = "linesbox linesbox4";
      }
  }

  div.id = "blank"+object.id;
  div.setAttribute("data-id",object.id);
  div.setAttribute("data-index",object.blank_index);
  div.setAttribute("data-group",object.blank_group);
  div.setAttribute("data-type",type);
  div.setAttribute("data-status",el_value.status);

  var y = (window.contentW/900)*object.y;
  var x = (object.x/900)*window.contentW;
  var w = (window.contentW/900)*object.w;
  var h = (window.contentW/900)*object.h;
  div.style.top = y+'px';
  div.style.left = x+'px';
  div.style.width = w+'px';
  div.style.height = h+'px';
  div.style.zIndex = "2";
  div.style.fontSize = (window.contentW/900)*20+"px";

  return div;
}
function selLinesBox(that){
    var gid = that.getAttribute("data-group");
    var type = that.getAttribute("data-type");
    if(type == "3"){
        var now_blank_id = selectGroup(parseInt(gid));
        var id = parseInt(that.getAttribute("data-id"));
        var b_index = that.getAttribute("data-index");
        var now_el_id = that.getAttribute("id");

        if(now_blank_id != ""){
          //已选择同组的答案
            $api.byId(""+now_blank_id).className = "linesbox";
            delAnswer(now_blank_id);
            if(now_blank_id == now_el_id){
                //取消答案（圈一圈）
                addAnswer(id,"0");
            }else{
                var item = {};
                item.g_id = parseInt(gid);
                item.el_id = now_el_id;
                now_sel_group.push(item);
                var now_blank_id = checkAnswer(id);
                if(now_blank_id == 0){
                    that.className = "linesbox linesbox2";
                }else{
                    $api.byId('blank'+now_blank_id).className = "linesbox";
                    that.className = "linesbox linesbox2";
                }
                addAnswer(id,"1");
            }
        }else{
            var item = {};
            item.g_id = parseInt(gid);
            item.el_id = now_el_id;
            now_sel_group.push(item);
            var now_blank_id = checkAnswer(id);
            if(now_blank_id == 0){
                that.className = "linesbox linesbox2";
            }else{
                $api.byId('blank'+now_blank_id).className = "linesbox";
                that.className = "linesbox linesbox2";
            }
            addAnswer(id,"1");
        }
    }
}

function selectGroup(g_id){
    var b = "";
    for(var i=0;i<now_sel_group.length;i++){
        if(now_sel_group[i].g_id == g_id){
            b = now_sel_group[i].el_id;
            now_sel_group.splice(i,1);
            break;
        }
    }
    return b;
}
/**************************************************************** END 圈一圈*********************************************************************************/

/**************************************************************** 连线题 *********************************************************************************/
// 创建画布
function createCanvas(list,type){
    window.canvas = document.createElement('canvas');
    window.canvas.id = "canvas"+question_index;
    window.canvas.width = $api.byId('questionpic').offsetWidth;
    window.canvas.height = $api.byId('questionpic').offsetHeight;
    window.canvas.style.position = "absolute";
    window.canvas.style.top = "0";
    window.canvas.style.left = "0";
    window.canvas.style.zIndex = "1";
    $api.byId("content").appendChild(canvas);

    lineBox(list,type);
}
// 选择框
function lineBox(list,type){
    for(var i=0;i<list.length;i++){
      var el = null;
      if(list[i].blank_group == ""){
        el = createInput(list[i]);
      }else{
        el = lianXianBox(list[i],type);
      }
      $api.byId("content").appendChild(el);
    }
    copy_line_data();

    // console.log(JSON.stringify(now_answer_list));
}
// 连线题的框
function lianXianBox(object,type){
  var el_value = checkElAnswerLine(object.id);
  // console.log(JSON.stringify(el_value));

  var div = document.createElement("DIV");


  if(el_value.status == 0){
      if(el_value.blank_id == "0" || el_value.blank_id == ""){
          div.className = "linesbox";
      }else{
          div.className = "linesbox linesbox2";
      }
      div.onclick=function(){
          selLianxianBox(this);
      }
  }else if(el_value.status == 1){
      if(el_value.baseanswer == "" || el_value.baseanswer == "0"){
          div.className = "linesbox";
      }else{
          div.className = "linesbox linesbox2";
      }
  }else{
      div.className = "linesbox linesbox2";
  }

  if(el_value.status > 0){
      div.onmousedown=function(){
          showLineAnswer(this);
      }
  }
  if(el_value.status > 0){
      div.onclick=function(){
          showLineAnswer(this);
      }
  }

  div.id = "blank"+question_index+'_'+object.blank_index;
  div.setAttribute("data-id",object.id);
  div.setAttribute("data-index",object.blank_index);
  div.setAttribute("data-group",object.blank_group);
  div.setAttribute("data-mul",object.mul_type);
  div.setAttribute("data-type",type);

  var y = (window.contentW/900)*object.y;
  var x = (object.x/900)*window.contentW;
  var w = (window.contentW/900)*object.w;
  var h = (window.contentW/900)*object.h;
  div.style.top = y+'px';
  div.style.left = x+'px';
  div.style.width = w+'px';
  div.style.height = h+'px';
  div.style.zIndex = '2';
  if(object.blank_group != ""){
    var answer = findAnswer(object.id);
    var answer2 = checkNewLine(object.id);
    var obj = {};
    obj.g_id = object.blank_group;
    obj.id = object.id;
    obj.bindex = object.blank_index;
    obj.mul = object.mul_type;
    obj.x = parseInt(x+(w/2));
    obj.y = parseInt(y+(h/2));
    obj.child = el_value.answer_child;
    obj.otherid = 0;
    obj.status = el_value.status;
    obj.index = question_index;
    // console.log(answer2)
    if(answer2 > 0){
        obj.child = answer2;
    }else{
        obj.child = answer.child;
    }
    createLineObject(obj);
    if(el_value.status > 0 || el_value.answer_child != ""){
        short_line_list.push(obj);
    }
  }

  div.style.fontSize = (window.contentW/900)*20+"px";
  return div;
}
//显示正确的答案
function showLineAnswer(that){
    if($api.byId("canvastwo"+question_index)){
        $api.byId("canvastwo"+question_index).remove();
    }
    var id = that.getAttribute("data-id");
    for(var i=0;i<answer_data.length;i++){
        if(answer_data[i].blank_id == parseInt(id)){
          // console.log(JSON.stringify(answer_data[i]))
            if(answer_data[i].answer_base > 0){
                var id2 = $api.byId("blank"+question_index+'_'+answer_data[i].answer_base).getAttribute("data-id");
                showAanswerCanvas(parseInt(id),parseInt(id2))
                break;
            }
        }
    }
}
//将答案备份到 short_line_list 列表（用于构造直线）
function copy_line_data(){
    for(var i=0;i<short_line_list.length;i++){
      var item = short_line_list[i];
        if($api.byId("blank"+item.index+'_'+item.child)){
            $api.byId("blank"+item.index+'_'+item.child).className = "linesbox linesbox2";
            var el_id = $api.byId("blank"+item.index+'_'+item.child).getAttribute("data-id");
            item.otherid = el_id;
        }
    }
    selectedLine();
}

//在答案列表中寻找
function findAnswer(id){
    var b = {};
    b.child = 0;
    for(var i=0;i<answer_data.length;i++){
        if(id == answer_data[i].blank_id){
            b.child = answer_data[i].answer_child;
            break;
        }
    }
    return b;
}
//构造已连线的题的线
function selectedLine(){
    // console.log(JSON.stringify(short_line_list))
    for(var i=0;i<short_line_list.length;i++){
        if(short_line_list[i].child == 0){
            continue;
        }else if(short_line_list[i].index == question_index){
            freshLinellae(short_line_list[i].id,short_line_list[i].otherid);
        }
    }
}
// 添加连线的对象
function createLineObject(object){
    var b=true;
    for(var i=0;i<line_group.length;i++){
        if(line_group[i].id == object.id){
            b=false;
            line_group.splice(i,1,object);
            break;
        }
    }
    if(b){
        line_group.push(object);
    }
}
//
function checkNewLine(id){
    var b = 0;
    for(var i=0;i<short_line_list.length;i++){
        if(id == short_line_list[i].id){
          b = short_line_list[i].child;
          break;
        }
    }
    return b;
}

// 选择连线的对象
var now_line_group = "";//当前选择的组
var now_line_id = 0;//当前选择的blank_id
var short_line_list = [];
function selLianxianBox(that){
    var gid = that.getAttribute("data-group");
    var type = that.getAttribute("data-type");
    var id = that.getAttribute("data-id");
    var blank_id = that.getAttribute("data-index");
    var mulType = that.getAttribute("data-mul");

    if(check_line_answer(parseInt(id)) == 0){
        if(now_line_id == parseInt(id) && now_line_id > 0){
            that.className = "linesbox";
            now_line_group = "";
            now_line_id = 0;
            return;
        }
        if(now_line_group == ""){
            now_line_group = gid;
            now_line_id = parseInt(id);
            that.className = "linesbox linesbox2";
        }else if(now_line_group != gid){
            if(now_line_id > 0){
                // if(mulType == '0')return;
                createLinellae(now_line_id,parseInt(id));
                that.className = "linesbox linesbox2";
            }
        }
    }else{
        if(mulType == '0'){
            if(now_line_group != gid && now_line_group != "")return;
            clear_line(id);
            that.className = "linesbox";
        }else{
          if(now_line_group != ""){
              createLinellae(now_line_id,parseInt(id));
              that.className = "linesbox linesbox2";
          }
        }
    }

}

//创建直线
function createLinellae(id_1,id_2){
    //var context = canvas.getContext('2d');
    var object = null;
    var object2 = null;
    for(var i=0;i<line_group.length;i++){
        if(line_group[i].id == id_1){
            line_group[i].otherid = id_2;
            object = line_group[i];
        }
        if(line_group[i].id == id_2){
            line_group[i].otherid = id_1;
            object2 = line_group[i];
        }
    }

    if(object == null || object2 == null)return;

    object.child = object2.bindex;
    object2.child = object.bindex;

    check_short_line(object,object2);

    var context = window.canvas.getContext('2d');

    context.strokeStyle = '#24a2f6';

    // 设置线条的宽度
    context.lineWidth = 1;
    // 绘制直线
    context.beginPath();
    // 起点
   context.moveTo(object.x, object.y);
   // 终点
   context.lineTo(object2.x, object2.y);
   context.closePath();
   context.stroke();
   now_line_group = "";
   now_line_id = 0;
}

//显示答案的画布
function showAanswerCanvas(id1,id2){
  window.canvas2 = document.createElement('canvas');
  window.canvas2.id = "canvastwo"+question_index;
  window.canvas2.width = $api.byId('questionpic').offsetWidth;
  window.canvas2.height = $api.byId('questionpic').offsetHeight;
  window.canvas2.style.position = "absolute";
  window.canvas2.style.top = "0";
  window.canvas2.style.left = "0";
  window.canvas2.style.zIndex = "1";
  $api.byId("content").appendChild(window.canvas2);
  answerLinellae(id1,id2);
}
//重构画布
function freshCanvas(){
  $api.byId("canvas"+question_index).remove();
  window.canvas = document.createElement('canvas');
  window.canvas.id = "canvas"+question_index;
  window.canvas.width = $api.byId('questionpic').offsetWidth;
  window.canvas.height = $api.byId('questionpic').offsetHeight;
  window.canvas.style.position = "absolute";
  window.canvas.style.top = "0";
  window.canvas.style.left = "0";
  window.canvas.style.zIndex = "1";
  $api.byId("content").appendChild(canvas);
  freshLine();
}
// 重新构造连线
function freshLine(){
    // console.log(JSON.stringify(line_group));
    for(var i=0;i<line_group.length;i++){
        if(line_group[i].otherid == 0){
            continue;
        }else{
            // console.log(line_group[i].otherid)
            if(line_group[i].index == question_index)
            freshLinellae(line_group[i].id,line_group[i].otherid);
        }
    }
}
//重构直线
function freshLinellae(id_1,id_2){
    //var context = canvas.getContext('2d');
    var object = null;
    var object2 = null;
    for(var i=0;i<line_group.length;i++){
        if(line_group[i].id == id_1){
            line_group[i].otherid = id_2;
            object = line_group[i];
        }
        if(line_group[i].id == id_2){
            line_group[i].otherid = id_1;
            object2 = line_group[i];
        }
    }

    if(object == null || object2 == null)return;

    object.child = object2.bindex;
    object2.child = object.bindex;

    check_short_line(object,object2);

    var context = window.canvas.getContext('2d');
    if(object.status == 2){
        context.strokeStyle = 'red';
    }else{
        context.strokeStyle = '#24a2f6';
    }
    // 设置线条的宽度
    context.lineWidth = 1;
    // 绘制直线
    context.beginPath();
    // 起点
   context.moveTo(object.x, object.y);
   // 终点
   context.lineTo(object2.x, object2.y);
   context.closePath();
   context.stroke();
}
// 创建答案的直线
function answerLinellae(id_1,id_2){
    //var context = canvas.getContext('2d');
    var object = null;
    var object2 = null;
    for(var i=0;i<line_group.length;i++){
        if(line_group[i].id == id_1){
            line_group[i].otherid = id_2;
            object = line_group[i];
        }
        if(line_group[i].id == id_2){
            line_group[i].otherid = id_1;
            object2 = line_group[i];
        }
    }

    if(object == null || object2 == null)return;

    var context = window.canvas2.getContext('2d');

    context.strokeStyle = 'green';
    // 设置线条的宽度
    context.lineWidth = 1;
    // 绘制直线
    context.beginPath();
    // 起点
   context.moveTo(object.x, object.y);
   // 终点
   context.lineTo(object2.x, object2.y);
   context.closePath();
   context.stroke();
}


//添加/覆盖 连线的对象
function check_short_line(obj,obj2){
    var b=true;
    var c=true;
    for(var i=0;i<short_line_list.length;i++){
        if(short_line_list[i].id == obj.id){
          if(obj.mul == 0){
              short_line_list.splice(i,1,obj);
              b=false;
              break;
          }else{
              obj.child = "";
              short_line_list.splice(i,1,obj);
              b=false;
              break;
          }
        }
    }
    if(b){
        short_line_list.push(obj);
    }
    for(var i=0;i<short_line_list.length;i++){
        if(short_line_list[i].id == obj2.id){
          if(obj2.mul == 0){
              short_line_list.splice(i,1,obj2);
              c=false;
              break;
          }else{
              obj2.child = "";
              short_line_list.splice(i,1,obj2);
              c=false;
              break;
          }
        }
    }
    if(c){
        short_line_list.push(obj2);
    }

    var bb = true;
    var cc = true;
    for(var i=0;i<now_answer_list.length;i++){
        if(now_answer_list[i].blank_id == obj.id){
            now_answer_list[i].blank_id = obj.id;
            now_answer_list[i].answer_child = obj.child+'';
            bb = false;
        }
        if(now_answer_list[i].blank_id == obj2.id){
            now_answer_list[i].blank_id = obj2.id;
            now_answer_list[i].answer_child = obj2.child+'';
            cc = false;
        }
    }
    if(bb){
        var item1 = {};
        item1.blank_id = obj.id;
        item1.answer_child = obj.child+'';
        now_answer_list.push(item1);
    }
    if(cc){
        var item2 = {};
        item2.blank_id = obj2.id;
        item2.answer_child = obj2.child+'';
        now_answer_list.push(item2);
    }

    $api.setStorage('answerList', JSON.stringify(now_answer_list));

    // console.log(JSON.stringify(now_answer_list));
}

// 检查元素对象是否存在连线
function check_line_answer(id){
    var b = 0;
    for(var i=0;i<line_group.length;i++){
        if(line_group[i].id == id){
            b = line_group[i].otherid;
            break;
        }
    }
    return b;
}

// 清除元素对象连线
function clear_line(id){
    var other = 0;
    var index = null;
    var other2 = 0;
    var index2 = null;
    for(var i=0;i<line_group.length;i++){
        if(id == line_group[i].id){
            other = line_group[i].otherid;
            index = i;
            break;
        }
    }
    for(var i=0;i<short_line_list.length;i++){
        if(id == short_line_list[i].id){
            short_line_list.splice(i,1);
            break;
        }
    }
    for(var i=0;i<now_answer_list.length;i++){
        if(id == now_answer_list[i].blank_id){
            now_answer_list[i].answer_child = "";
            // now_answer_list.splice(i,1);
            break;
        }
    }

    if(other > 0){
      for(var i=0;i<line_group.length;i++){
          if(other == line_group[i].id){
              // if(line_group.mul == 0){
              //     $api.byId('blank'+line_group[i].bindex).className = "linesbox";
              // }
              line_group[i].otherid = 0;
              line_group[i].child = 0;
              break;
          }
      }

      for(var i=0;i<short_line_list.length;i++){
          if(other == short_line_list[i].id){
              if(short_line_list[i].mul == 0){
                  $api.byId('blank'+question_index+'_'+short_line_list[i].bindex).className = "linesbox";
              }else{
                  var count = check_short_list(short_line_list[i].bindex);
                  if(count == 0){
                      $api.byId('blank'+question_index+'_'+short_line_list[i].bindex).className = "linesbox";
                  }
              }
              short_line_list.splice(i,1);
              break;
          }
      }
      for(var i=0;i<now_answer_list.length;i++){
          if(other == now_answer_list[i].blank_id){
              now_answer_list[i].answer_child = "";
              // now_answer_list.splice(i,1);
              break;
          }
      }
    }

    now_line_group = "";
    now_line_id = 0;

    if(index != null){
      line_group[index].otherid = 0;
      line_group[index].child = 0;
    }

      // console.log(JSON.stringify(now_answer_list));
      $api.setStorage('answerList', JSON.stringify(now_answer_list));

    freshCanvas();

}
function check_short_list(id){
  var b=0;
  for(var i=0;i<short_line_list.length;i++){
      if(id == short_line_list[i].child){
          //
          b++;
      }
  }
  return b;
}
// 检查连线题是否填写过答案
function checkElAnswerLine(id){
  var b = {};
  b.blank_id = "";
  b.status = 0;
  b.baseanswer = "";
  b.answer_child = "";
  for(var i=0;i<answer_data.length;i++){
      if(id == answer_data[i].blank_id){
          // console.log(JSON.stringify(answer_data[i]));
          b.blank_id = answer_data[i].answer_child;
          b.status = answer_data[i].status;
          b.baseanswer = answer_data[i].answer_base;
          b.answer_child = answer_data[i].answer_child;
          break;
      }
  }
  if(b.blank_id == ""){
      for(var i=0;i<now_answer_list.length;i++){
          if(id == now_answer_list[i].blank_id){
              // console.log(JSON.stringify(now_answer_list[i]))
              b.blank_id = now_answer_list[i].answer_child;
              b.answer_child = now_answer_list[i].answer_child;
              break;
          }
      }
  }
  return b;
}
/****************************************************************END 连线题*********************************************************************************/


/****************************************************************输入框*********************************************************************************/
function inputBox(list){
    for(var i=0;i<list.length;i++){
      var el = createInput(list[i]);
      $api.byId("content").appendChild(el);
    }
}
//创建输入框
function createInput(object){

    var el_value = checkElAnswer(object.id);

    var inp = document.createElement("INPUT");
    if(el_value.blank_id == ""){
        // console.log(el_value.status);
        inp.setAttribute("data-answer",el_value.baseanswer);
        if(el_value.status == 0){
          inp.className = "inputel";
        }else if(el_value.status == 1){
          inp.className = "inputel inputfill";
        }else{
          inp.className = "inputel inputfail";
        }
    }else{
        if(el_value.status == 0){
            inp.className = "inputel inputfill";
            inp.setAttribute("data-answer",el_value.baseanswer);
        }
        if(el_value.status == 1){
            inp.setAttribute("data-answer",el_value.baseanswer);
            inp.className = "inputel inputfill";
        }
        if(el_value.status == 2){
            inp.setAttribute("data-answer",el_value.baseanswer);
            inp.className = "inputel inputfail";
        }
    }

    inp.id = "blank"+object.id;
    inp.setAttribute("data-id",object.id);

    var y = (window.contentW/900)*object.y;
    var x = (object.x/900)*window.contentW;
    var w = (window.contentW/900)*object.w;
    var h = (window.contentW/900)*object.h;
    inp.style.top = y+'px';
    inp.style.left = x+'px';
    inp.style.width = (w-2)+'px';
    inp.style.height = (h-2)+'px';
    inp.style.zIndex = '2';
    inp.style.fontSize = (window.contentW/900)*20+"px";
    inp.setAttribute("value",el_value.blank_id);
    inp.setAttribute("data-status",el_value.status);

    if(object.options.length > 0){
        inp.setAttribute("readonly","readonly");
        inp.setAttribute("options-type",0);
        inp.setAttribute("options",JSON.stringify(object.options));
        inp.onclick=function(){
            var e = window.event;
            e.stopPropagation();
            inputEvent(this);
        }
        inp.onfocus=function(){
          cancelBlur(this);
        }
    }else{
        inp.setAttribute("options-type",1);
        if(el_value.status == 0){
            inp.onfocus=function(){
                document.getElementsByClassName("bottom_btn")[0].style.display = "none";
                if($api.byId("serial")){
                    $api.byId("serial").remove();
                    now_sel_inp = "";
                }
            }
            inp.onblur=function(){
                document.getElementsByClassName("bottom_btn")[0].style.display = "block";
            }
        }else{
            inp.setAttribute("readonly","readonly");
        }
        if(el_value.status == 2){
            inp.setAttribute("readonly","readonly");
            inp.onclick=function(){
                var e = window.event;
                e.stopPropagation();
                inp.setAttribute("options",el_value.baseanswer);
                inputEvent(this);
            }
        }
    }
    inp.onchange=function(){
        changeInp(this);
    }

    return inp;
}
//取消光标
function cancelBlur(that){
    that.blur();
}
// 输入框的值发生改变
function changeInp(that){
  if(that.value != ""){
      that.className = "inputel inputfill";
      var id= parseInt(that.getAttribute("data-id"));
      addAnswer(id,that.value);
  }else{
      that.className = "inputel";
  }
}

// 检查元素对象是否填写过答案
function checkElAnswer(id){
    var b = {};
    b.blank_id = "";
    b.status = 0;
    b.baseanswer = "";
    for(var i=0;i<now_answer_list.length;i++){
        if(id == now_answer_list[i].blank_id){
            b.blank_id = now_answer_list[i].answer_child;
            break;
        }
    }
    if(b.blank_id == ""){
        for(var i=0;i<answer_data.length;i++){
            if(id == answer_data[i].blank_id){
                b.blank_id = answer_data[i].answer_child;
                b.status = answer_data[i].status;
                b.baseanswer = answer_data[i].answer_base;
                break;
            }
        }
    }
    return b;
}

// 检查元素对象是否填写过答案
function checkElAnswer2(id){
    var b = "";
    for(var i=0;i<now_answer_list.length;i++){
        if(id == now_answer_list[i].blank_id){
            b = now_answer_list[i].blank_id;
            break;
        }
    }
    if(b == ""){
        for(var i=0;i<answer_data.length;i++){
            if(id == answer_data[i].blank_id){
                b = answer_data[i].blank_id;
                break;
            }
        }
    }
    return b;
}

// 添加答案到本地集合
function addAnswer(id,value){
    var b = true;
    for(var i=0;i<now_answer_list.length;i++){
        if(now_answer_list[i].blank_id == id){
            now_answer_list[i].answer_child = value;
            b = false;
            break;
        }
    }
    if(b){
        var item = {};
        item.blank_id = id;
        item.answer_child = value;
        now_answer_list.push(item);
    }

    $api.setStorage('answerList', JSON.stringify(now_answer_list));
}

function delAnswer(id){
    var b = false;
    for(var i=0;i<now_answer_list.length;i++){
        if(now_answer_list[i].blank_id == id){
            now_answer_list[i].answer_child = '';
            b = true;
            break;
        }
    }
    return b;
}

//检查对象是否被选中
function checkAnswer(id){
    var b = 0;
    for(var i=0;i<now_answer_list.length;i++){
        if(now_answer_list[i].blank_id == id){
            b = now_answer_list[i].blank_id;
            break;
        }
    }
    return b;
}

// 点击选项的输入框
function inputEvent(that){
    // alert(that.getAttribute("options"))
    if(that.getAttribute("options-type") == "0"){
        createSerial(that,JSON.parse(that.getAttribute("options")),0);
    }else{
        createSerial(that,that.getAttribute("options"),1);
    }
    // createSerial(that,JSON.parse(that.getAttribute("options")));
}

// 创建填空题的选项
function createSerial(inpthat,list,answertype){

    var div = null;

    if(now_sel_inp == inpthat.getAttribute("id")){
        if($api.byId("serial"))
        $api.byId("serial").remove();
        now_sel_inp = "";
        return;
    }

    if($api.byId("serial")){
        $api.byId("serial").remove();
    }

    div = document.createElement('DIV');

    var items = '';

    // 判断status
    var serialstatus = inpthat.getAttribute("data-status");
    if(serialstatus == "2"){
        if(typeof(list) == "string" || typeof(list) == "number"){
            items = '<span style="color:#24a2f6;">'+list+'</span>';
        }
        div.className = "serial serial2";
    }else{
        div.className = "serial";
    }

    // 正确答案
    var correct = inpthat.getAttribute("data-answer");

    div.id = "serial";

    now_sel_inp = inpthat.getAttribute("id");

    var clickway = "";
    if(serialstatus == "0"){
        clickway = 'onclick="selectItem(this)"';
    }
    if(answertype == 0){
        div.innerHTML = "";
        for(var i=0;i<list.length;i++){
            var val = list[i] == ""?"空":list[i];
            var cls = "";

            // var spanhtml = document.createElement("SPAN");

            if(correct == val){
                cls = "correct_answer";
            }else if(val == inpthat.value){
                cls = "error_answer";
            }

            items += '<span '+clickway+' class="'+cls+'" data="'+now_sel_inp+'" data-val="'+list[i]+'">'+val+'</span>';
        }
        items += '<i></i>';
    }
    div.innerHTML = items;
    $api.byId("content").appendChild(div);


    var divhalf = parseInt(div.offsetWidth/2);
    var rightW = window.contentW - (inpthat.offsetWidth+inpthat.offsetLeft);
    var shortleft = inpthat.offsetLeft - divhalf;

    if(divhalf < inpthat.offsetLeft && divhalf < rightW){
        div.style.left = shortleft+(inpthat.offsetWidth/2)+"px";
    }else if(divhalf > rightW){
        div.style.left = window.contentW - (div.offsetWidth+10)+"px";
    }else if(divhalf > inpthat.offsetLeft){
        div.style.left = "0px";
    }

    if((div.offsetHeight - inpthat.offsetTop) > 40){
        div.style.top = inpthat.offsetTop + (10 + inpthat.offsetHeight)+"px";
    }else{
        div.style.top = inpthat.offsetTop - (div.offsetHeight + 10)+"px";
    }
    div.style.zIndex = '2';
}

function inpBlur(that){
  that.blur();
}

// 选择选项
function selectItem(that){
    var el_id = that.getAttribute("data");
    if($api.byId(el_id)){
        var that_value = that.getAttribute("data-val");
        var inputEl = $api.byId(el_id);
        if(that_value == ""){
            inputEl.className = "inputel";
        }else{
            inputEl.className = "inputel inputfill";
        }
        inputEl.value = that_value;
        var id = inputEl.getAttribute("data-id");
        addAnswer(parseInt(id),that_value);
        that.parentNode.style.display = "none";
        now_sel_inp = "";
    }
}
/****************************************************************END输入框*********************************************************************************/

// 上一题
function preQuestion(){
  if(question_list.length == 0)return;
  if(question_index == 0)return;

  initContent();

  now_sel_group = [];

  now_line_group = "";
  now_line_id = 0;

  document.getElementsByClassName("complete")[0].style.display="none";
  document.getElementsByClassName("nextpage")[0].style.display="block";

  question_index--;
  createQuestion(question_list[question_index]);
}
// 下一题
function nextQuestion(){
  if(question_list.length == 0)return;
  if(question_index == question_list.length-1)return;

    initContent();

    now_sel_group = [];

    now_line_group = "";
    now_line_id = 0;

    question_index++;
    if(question_index == question_list.length-1){
      document.getElementsByClassName("nextpage")[0].style.display="none";
      document.getElementsByClassName("complete")[0].style.display="block";
    }
    createQuestion(question_list[question_index]);
}
// 提交答卷
function submitCheck(){
    checkSubmitAnswer();
}
function submitAnswer(callback){

    $api.send("api/resume_sys/do_answer/","post",{child_id:now_child_id,answer_list:JSON.stringify(now_answer_list)},function(data){
        // console.log(JSON.stringify(data));
        if(data.code == 0){
            $api.error(data.error_msg);
        }else{
            if(callback){
                callback();
            }
            api.sendEvent({
              name:'upd_home_subject'
            });
        }
    },true);
}

// 检查是否还有题目未填写答案
function checkSubmitAnswer(){
    var list = [];
    for(var i=0;i<question_list.length;i++){
        for(var j=0;j<question_list[i].blank_list.length;j++){
            var item = question_list[i].blank_list[j];
            if(checkElAnswer2(item.id) == ""){
                if(question_list[i].type != 3){
                    if(question_list[i].type == 1){
                      var b = false;
                      for(var k=0;k<item.options.length;k++){
                          if(item.options[k] == ""){
                            b = true;
                            break;
                          }
                      }
                      if(!b){
                          list.push(item.id);
                      }else{
                          // 当填空题为空时
                          var items = {};
                          items.blank_id = item.id;
                          items.answer_child = "";
                          now_answer_list.push(items);
                      }
                    }else{
                      list.push(item.id);
                    }
                }else{
                    var items = {};
                    items.blank_id = item.id;
                    items.answer_child = "0";
                    now_answer_list.push(items);
                }
            }
        }
    }

    // console.log(JSON.stringify(now_answer_list));

    if(list.length>0){
        $api.confirm({
            title:"",
            msg:"还有题目尚未作答，您确定要提交吗？",
            buttons:["取消","确定"]
        },function(ret,err){
            if(ret.buttonIndex == 2){
                for(var i=0;i<list.length;i++){
                    var item = {};
                    item.blank_id = list[i];
                    item.answer_child = "";
                    now_answer_list.push(item);
                }

                submitAnswer(function(){
                  endSubmitAnswer();
                });
            }
        })
    }else{
      submitAnswer(function(){
          endSubmitAnswer();
      });
    }

    // checkElAnswer();
}
// 最终答卷提交
function endSubmitAnswer(){

    $api.send("api/resume_sys/commit_answer/","post",{paper_id:param.id,child_id:now_child_id},function(data){
        // console.log(JSON.stringify(data));
        if(data.code == 0){
            $api.error(data.error_msg);
        }else{
            answer_data = data.list;
            createQuestion(question_list[question_index]);

            $api.rmStorage("answerList");

            checkError();

        }
    },true);
}


function initContent(){
  $api.byId("wrap").style.width = "100%";
  $api.byId('content').innerHTML = "";
  now_sel_inp = "";

  var imgEl = document.createElement("IMG");
  imgEl.id = "questionpic";
  $api.byId('content').appendChild(imgEl);
}

// 创建目录
function createMulu(){
    var listEl = $api.byId('mulu_list');
    listEl.innerHTML = "";
    for(var i=0;i<question_list.length;i++){
        var is_error = checkAnswerError(i);
        var colors = "#000 !important";
        if(is_error){
          colors = "red !important";
        }
        var lable = document.createElement("LABEL");
        lable.className = "mulu_item";
        lable.innerHTML = "<div data='"+i+"' style='color:"+colors+"' onclick='selectMulu(this)'>"+question_list[i].title+"</div>";
        listEl.appendChild(lable);
    }

    $(".mulu_item img").each(function(i,n){
        var muluname = window.ImgURL+'sub/img/'+$(n).attr("src");
        $(n).attr("src",muluname);
    })
}

// 检查存在错的题
function checkAnswerError(index){

    var b = false;
    for(var i=0;i<question_list[index].blank_list.length;i++){
        var item = question_list[index].blank_list[i];
        for(var j=0;j<error_count.length;j++){
          if(error_count[j].blank_id == item.id){
              b = true;
              break;
          }
        }
    }
    return b;
}

// 答题的正确率
var error_count = [];
function checkError(){
    now_answer_list = [];//当前答题中选择的答案选项

    error_count = [];
    for(var i=0;i<answer_data.length;i++){
        if(answer_data[i].status == 2){
            error_count.push(answer_data[i]);
        }
    }

    document.getElementsByClassName("bottom_btn")[0].style.display = "none";
    document.getElementsByClassName("sub_question")[0].style.display = "none";
    document.getElementsByClassName("bottom_btn2")[0].style.display = "block";

    hideMulu();

    api.setScreenOrientation({
      orientation: 'portrait_up'
    });

    setTimeout(function(){
        $api.byId("results_wrap").style.display = "block";
    },100);

    var accuracy = 100 - (error_count.length/answer_data.length)*100;

    $api.byId('results_ratio').innerText = "正确率 "+parseFloat(accuracy).toFixed(2)+"%";

    var text = "";
    if(accuracy < 60){
      text = "差";
    }else if(accuracy < 80){
      text = "中";
    }else if(accuracy < 90){
      text = "良";
    }else{
      text = "优";
    }

    $api.byId('results_box').innerText = text;

    if(parseInt(param.audio) > 0){
      $api.byId("audiobox_wrap").style.display = "block";

      $api.byId('audiobox').setAttribute("controls","true");

      $api.byId("audiobox").pause();
    }


}

// 选择题目
function selectMulu(that){
  var index = that.getAttribute("data");
  question_index = parseInt(index);
  if(question_index == question_list.length -1){
    document.getElementsByClassName("nextpage")[0].style.display="none";
    document.getElementsByClassName("complete")[0].style.display="block";
  }else{
    document.getElementsByClassName("complete")[0].style.display="none";
    document.getElementsByClassName("nextpage")[0].style.display="block";
  }
  initContent();
  createQuestion(question_list[question_index]);
	hideMulu();
}
// 显示目录
function showMulu(){
	document.getElementsByClassName("mulu_wrap")[0].style.display = "block";
}
// 隐藏目录
function hideMulu(){
	document.getElementsByClassName("mulu_wrap")[0].style.display = "none";
  $api.byId("results_wrap").style.display = "none";
}


function pageBack(){
    // $api.close();
    $api.open("book_list","../book_list/book_list.html",{bookid:param.book_id,bookname:param.book_name,grade:param.grade,child_id:now_child_id},false,true);
}
function lookBack(){
    createMulu();
    setTimeout(showMulu,100);
}



//
