var db = null;

window.cypy_info = {company_id:0};
var user_infos = null;


window.reload_icon = [];
var is_down_icon = true;


apiready = function(){

    // $api.fixedHeader();

    $api.getStatusBar();

    init();
}
function setStatusBar(){
  $api.byId('contacts').style.paddingTop = (window.headerPos.h+10)+"px";

}


function init(){

    $api.byId('cencel_page').onclick=function(){
        $api.close();
    };

    setStatusBar();

    var data = $api.getStorage('userinfo');
    if(data != "" && data != "undefined"){
        user_infos = JSON.parse(data);
    }


    if(window.app_type == "APP"){
        db = new DB("msg_db");
        if(db.is_connect)db.init_db();
    }



}

function do_search(){
    if(db == null)return;

    if($api.getToken() == ""){
        $api.open("login","../login/login.html",false,true);
        return;
    }


    var val = $api.byId("search_inp").value;

    if(val == ""){

        $api.byId("list").innerHTML = '';

    }else{

        $api.byId("list").innerHTML = '';

        var list = db.get_my_session_book(user_infos.id,window.cypy_info.company_id,val);

        var grouplist = db.get_my_group_book(user_infos.id,window.cypy_info.company_id,val);


        if(grouplist.length > 0)
        for_group_list(grouplist);


        if(list.length > 0)
        for_book_list(list);


        if(grouplist.length == 0 && list.length == 0){
            $api.tips("搜索结果为空");
        }


    }

}


// 群组
function for_group_list(list){
    for(var i=0;i<list.length;i++){
        var element = create_group_element(list[i]);
        $api.byId("list").appendChild(element);
    }
}

// 好友
function for_book_list(list){
    for(var i=0;i<list.length;i++){
        var element = create_session_element(list[i]);
        $api.byId("list").appendChild(element);
    }

    if(!is_down_icon)return false;

    down_user_icon()
}


// 创建好友UI
function create_session_element(object){

    var iconstr = "";
    if(object.local_icon == "" && object.icon != ""){
        window.reload_icon.push(object);
    }else if(object.local_icon != ""){
        iconstr = object.local_icon;
    }else{
        iconstr = "../../image/icon003.png";
    }

    var name = "";
    if(object.descn != ""){
        name = object.descn == ""?object.name:object.name+'('+object.descn+')';
    }else{
        name = object.name==""?"昵称未设置":object.name;
    }

    var div = document.createElement("DIV");
    div.className = "friends_item";
    div.id = "group_session"+object.session_id;
    div.setAttribute("session-id",object.session_id);
    div.setAttribute("session-name",name);
    div.setAttribute("session-type",1);
    div.onclick = function(){openChatview(this)};
    div.innerHTML = '<div class="friends_icon"><img id="icon'+object.session_id+'" src="'+iconstr+'"></div>'+
        '<span>'+name+'</span>';

    return div;

}

// 创建群组UI
function create_group_element(object){

    var div = document.createElement("DIV");
    div.className = "friends_item";
    div.id = "group_session"+object.session_id;
    div.setAttribute("session-id",object.session_id);
    div.setAttribute("session-name",object.session_name);
    div.setAttribute("session-type",'group');
    div.onclick = function(){openChatview(this)};
    div.innerHTML = '<div class="friends_icon"><img id="icon'+object.session_id+'" src="../../image/chat_group.png"></div>'+
        '<span>'+object.session_name+'</span>';

    return div;

}

// 打开聊天窗口
function openChatview(obj){
    var id = obj.getAttribute("session-id");
    var name = obj.getAttribute("session-name");
    var type = obj.getAttribute("session-type");
    $api.open("chatview","../chatview/chatview.html",{lx:id,type:type,name:name},false,true);
}


//下载用户头像
function down_user_icon(){
    is_down_icon = false;
    if(window.reload_icon.length == 0){
        is_down_icon = true;
        return;
    }

    var param;
    if(window.reload_icon[0].local_icon != ""){
        param={
            url:window.ImgURL+window.reload_icon[0].icon,
            savePath:window.reload_icon[0].local_icon
        }
    }
    else{
        param={
            url:window.ImgURL+window.reload_icon[0].icon
        }
    }

    api.download(param,function(ret,err){
      if(ret.state == 1){
        db.update_user_icon(window.reload_icon[0].user_id,ret.savePath);
        $api.byId('icon'+window.reload_icon[0].session_id).setAttribute("src",ret.savePath);
      }else{
        $api.byId('icon'+window.reload_icon[0].session_id).setAttribute("src","../../image/icon003.png");
      }
      window.reload_icon.splice(0,1);
      down_user_icon();
    })
}
