

var student_data = {};

var type_id = 2;

var now_card_id = 0;

var sel_student_card_id = 0;
var sel_student_card_name = "";

apiready=function()
{

	$api.getStatusBar();

	init();

}
function setStatusBar(){
	$api.byId("wrap").style.paddingTop = (window.headerPos.h+10)+"px";
}


if(window.app_type=="WEB")
window.onload = function(){
	init();
}

function init(){

  	$api.byId("back_page").onclick = function(){
  		  $api.close();
    };

		setStatusBar();

    baseimg[0].imgbase="../../public/images/icon_base_man.png";
    baseimg[1].imgbase="../../public/images/icon_base_woman.png";

    var data = $api.getPageParam("data");
    if(data == "" || data == "undefined"){
        return false;
    }else{
        student_data = JSON.parse(data);
        $api.byId('student_name').value = student_data.student_name;
        if(student_data.student_pic > 0){
            $api.byId("student_pic").setAttribute("src",window.HostURL+"api/resume_company/get_student_pic/"+$api.getToken()+"/?company_token="+$api.getCompanyToken()+"&id="+student_data.student_pic);
        }else{
            var picurl = student_data.student_sex==1?baseimg[0].imgbase:baseimg[1].imgbase;
            $api.byId("student_pic").setAttribute("src",picurl);
        }
    }

    $api.byId("student_card").onclick=function(){
        $api.byId('student_list_wrap').style.display = "block";
    }

    $api.byId("ensureBtn").onclick=function(){
        now_card_id = sel_student_card_id;
        $api.byId('student_card').value = sel_student_card_name;
        $api.byId('student_list_wrap').style.display = "none";
				get_echarts();
    }
    $api.byId("cancelBtn").onclick=function(){
        $api.byId('student_list_wrap').style.display = "none";
    }

    $api.byId("look_detail").onclick=function(){
      if(now_card_id == 0){
          $api.tips("请选择学员卡");
      }else{
          $api.open("comment_detail","../comment_detail/comment_detail.html",{data:data,card_name:sel_student_card_name,card_id:sel_student_card_id},false,true);
      }

    }

    get_student_card();

}


function inpOnblur(that){
		that.blur();
}


// 获取学员卡
function get_student_card(){

  $api.send("api/resume_company/get_student_card_list_id/","post",{student_id:student_data.id},function(data){
      // console.log(JSON.stringify(data));
      if(data.code == 0){
          $api.error(data.error_msg);
      }else{
          if(data.list.length > 0){
              now_card_id = data.list[0].id;
              sel_student_card_id = data.list[0].id;
              sel_student_card_name = data.list[0].card_name;
              $api.byId('student_card').value = sel_student_card_name;
              for_student_card(data.list);
							get_echarts();
          }

      }
  },true);

}

/**/
function for_student_card(list){
  for(var i=0;i<list.length;i++){
    set_student_card(list[i]);
  }
  if(window.zero_swiper == null){
    zero_swiper_new();
  }
  if(now_card_id > 0){
    if($api.byId('student_card'+now_card_id)){
      $api.byId('student_card'+now_card_id).classList.add('sel_student_card');
    }
  }
}
/**/
function set_student_card(data)
{
  var div = document.createElement('DIV');
  div.id = 'student_card'+data.id;
  div.className = 'swiper-slide card_box';
  div.setAttribute('data-id',data.id);
  div.setAttribute('data-name',data.card_name);
  var cardtype = data.card_type==1?'班级授课':'一对一授课';
  var coursetype = data.course_type==1?'培训类':'托管类';
  var valid = '';
  var endtime = '';
  var count = '';
  var stu_pic = '';
  if(data.end_time == ''){
    endtime = '<span>长期有效</span>';
  }else{
    if(!compare_date(data.end_time)){
      div.className = 'swiper-slide card_box no_card_box';
    }
    endtime = '<span>'+data.end_time.substr(0,10)+'</span>到期';
  }
  if(data.total_count == 0){
    count = '<span>不限次</span>';
  }else{
    count = '<span>'+data.left_count+'</span>/'+data.total_count+'次';
  }

  switch(data.invalid_type){
    case 0:
    valid = '长期';
    break;
    case 1:
    valid = '<span>'+data.invalid_val+'天</span>';
    break;
    case 2:
    valid = '<span>'+data.invalid_val+'月</span>';
    break;
    case 3:
    valid = '<span>'+data.invalid_val+'年</span>';
    break;
  }
  div.onclick=function(){sel_student_card(this)};
  div.innerHTML = '<div class="student_card">'+
        '<p class="student_card_name">'+data.card_name+'</p>'+
        '<p class="student_card_count"><span>'+count+'</p>'+
        '<p class="course_card_name">'+data.course_name+'</p>'+
        '<p class="end_time">'+endtime+'</p>'+
        '<p class="card_valid">'+valid+'有效</p>'+
        '<p class="course_type">'+coursetype+'</p>'+
        '<p class="card_type">'+cardtype+'</p>'+
      '</div>';
  $api.byId('zero_list').appendChild(div);

}

//
function sel_student_card(that){


    if(sel_student_card_id > 0){
      if($api.byId('student_card'+sel_student_card_id)){
        $api.byId('student_card'+sel_student_card_id).classList.remove('sel_student_card');
      }
    }
		sel_student_card_id = that.getAttribute("data-id");
		sel_student_card_name = that.getAttribute("data-name");

    $api.byId('student_card'+sel_student_card_id).classList.add('sel_student_card');

}

//
function get_echarts(){
    $api.send("api/resume_company/get_comment_list_days/","post",{student_id:student_data.id,student_card_id:now_card_id,type:type_id},function(data){
        // console.log(JSON.stringify(data));
        if(data.code == 0){
            $api.error(data.error_msg);
        }else{
            var days = [];
            var comments= [];
            if(data.list.length > 0){
                for(var i=0;i<data.list.length;i++){
                    var day = data.list[i].sch_time.substr(5,5);
                    days.push(day);
                    var level = 0;
                    if(data.list[i].comment_level >0){
                        level = 4 - data.list[i].comment_level;
                    }
                    comments.push(level);
                }
            }
						echartsLine(days,comments);
        }
    },false)
}




//
function changeType(that){
    document.getElementsByClassName("active_type")[0].classList.remove("active_type");
    type_id = parseInt(that.getAttribute("data"));
    that.className = "active_type";
    get_echarts();
}

//
function echartsLine(day,comment){
    var option = {
        title:{
            text:'点评',
            textStyle:{
              lineHeight: 20,
              height:20,
              fontSize:14
            }
        },
        tooltip:{},
        legend:{
            data:[3,2,1]
        },
        xAxis:{
            data:day
        },
        yAxis:{
            data:['无','C','B','A']
        },
        series:[{
            name:'',
            type:'line',
            color:"#24a2f6",
            data:comment
        }]
    };
    //初始化echarts实例
    var myChart = echarts.init(document.getElementById('echarts_line'));

    //使用制定的配置项和数据显示图表
    myChart.setOption(option);

}



/* 创建Swiper */
function zero_swiper_new(){
  if(window.zero_swiper != null)return;
  window.zero_swiper = new scrollView("sel_list",function(ret,err){

	})
}
/* END 创建Swiper */

/*比较时间*/
function compare_date(str){
  var date = new Date();
  var now_date = date.getTime();
  var str_date = Date.parse(str.replace(/-/g,"/"));
  if(str_date > now_date){
    return true;
  }else{
    return false;
  }
}







//
