


var edit_type = 0;

var class_list = [{id:1,name:"一年级"},{id:2,name:"二年级"},{id:3,name:"三年级"},{id:4,name:"四年级"},{id:5,name:"五年级"},{id:6,name:"六年级"}];

var sex_id = 1;

var class_id = 1;

var child_id = 0;

var child_pic = "";

var child_info = {};

apiready=function(){

  $api.getStatusBar();

  init();

}
function setStatusBar(){
  $api.byId('wrap').style.paddingTop = (window.headerPos.h+10)+"px";
}

function init(){
    $api.byId('back_page').onclick=function(){
        $api.close();
    };

    setStatusBar();

    baseimg[0].imgbase="../../public/images/icon_base_man.png?11";
    baseimg[1].imgbase="../../public/images/icon_base_woman.png?11";

    var type = $api.getPageParam("type");
    if(type == "" || type == "undefined" || type == 0){
        edit_type = 0;
    }else{
        var data = $api.getPageParam("data");
        if(data == "" || data == "undefined"){
          return;
        }
        child_info = JSON.parse(data);
        dispose_child_info(child_info);
        edit_type = type;
    }
    check_edit();

    var nowdate = new Date();
    var nowmonth = nowdate.getMonth()+1;
    var nowyear = nowdate.getFullYear();
    var calendar = new LCalendar();
    calendar.init({
        'trigger': '#student_born',
        'type': 'ym',
        'minDate':'2000-01-01',
        'maxDate':'2015-12-31'
    });
    /*选择*/

    //选择性别
  	var sex_sel = new selectSwiper({
  		el: '.select_box_sex',
  		mustSelect: true,
  		activeIndex: sex_id - 1,
  		data: [{id:1,name:"男"},{id:2,name:"女"}],
  		init: function(index) {

  		},
  		okFunUndefind:function(){

  		},
  		okFun: function(index) {
          sex_id = this.data[index].id;
          $api.byId('student_sex').value = this.data[index].name;
  		}
  	});
    $api.byId('student_sex').onclick=function(){
      sex_sel.openSelectSwiper();
    }

    //选择年级
  	var class_sel = new selectSwiper({
  		el: '.select_box_class',
  		mustSelect: true,
  		activeIndex: class_id - 1,
  		data: class_list,
  		init: function(index) {

  		},
  		okFunUndefind:function(){

  		},
  		okFun: function(index) {
          class_id = this.data[index].id;
          $api.byId('student_class').value = this.data[index].name;
  		}
  	});
    $api.byId('student_class').onclick=function(){
      class_sel.openSelectSwiper();
    }

    // 选择入学年份
    var yearlist = [];
    for(var i=0;i<6;i++){
        var item = {};
        item.id = nowyear-i;
        item.name = nowyear-i+"年";
        yearlist.push(item);
    }
  	var year_sel = new selectSwiper({
  		el: '.select_box_year',
  		mustSelect: true,
  		activeIndex: 0,
  		data: yearlist,
  		init: function(index) {

  		},
  		okFunUndefind:function(){

  		},
  		okFun: function(index) {
          class_id = this.data[index].id;
          $api.byId('student_year').value = this.data[index].name;
  		}
  	});
    $api.byId('student_year').onclick=function(){
        year_sel.openSelectSwiper();
    }

    // 上传头像
    $api.byId('upload').onclick=function(){
        $api.showChooseimg(function(base){
      		  child_pic = base;
            $api.byId('childpic').setAttribute("src","data:image/jpeg;base64,"+child_pic);
      	},true);
    };


    // 保存
    $api.byId('save_children').onclick=function(){
        edit_children();
    };



}

// 判断 添加还是编辑
function check_edit(){
    if(edit_type == 0){
        $api.byId('page_title').innerText = "添加孩子信息";
        $api.byId('school_year').style.display="block";
    }else{
        $api.byId('page_title').innerText = "编辑孩子信息";
        $api.byId('student_grade').style.display="block";
    }
}

function dispose_child_info(object){

    $api.byId('student_name').value = object.child_name;
    $api.byId('student_sex').value = object.child_sex == 1?"男":"女";

    child_id = object.id;
    sex_id = object.child_sex;
    class_id = object.grade;

    switch (object.grade) {
      case 1:
        $api.byId('student_class').value = "一年级";
      break;
      case 2:
        $api.byId('student_class').value = "二年级";
      break;
      case 3:
        $api.byId('student_class').value = "三年级";
      break;
      case 4:
        $api.byId('student_class').value = "四年级";
      break;
      case 5:
        $api.byId('student_class').value = "五年级";
      break;
      case 6:
        $api.byId('student_class').value = "六年级";
      break;
      default:
      $api.byId('student_class').value = "请选择孩子的年级";
    }

    $api.byId('student_born').value = object.child_birthday.substr(0,7);

    if(object.child_pic > 0){
        $api.byId('childpic').setAttribute("src",window.HostURL+"api/resume_sys/get_child_pic/?id="+object.child_pic);
    }else{
        $api.byId('childpic').setAttribute("src",object.child_sex == 1?baseimg[0].imgbase:baseimg[1].imgbase);
    }

}

// resume_sys/edit_child
function edit_children(){

    var name = $api.byId('student_name').value;
    var born = $api.byId('student_born').value;
    if(name == ""){
      $api.tips("请填写孩子的姓名");
      return;
    }
    if(child_id == 0){
        if(class_id == 0){
          $api.tips("请选择孩子的入学年份");
          return;
        }
    }else{
        if(class_id == 0){
          $api.tips("请选择孩子的年级");
          return;
        }
    }
    if(born == ""){
      $api.tips("请选择孩子的出生年月");
      return;
    }
    born = born+'-01';

    var send_data = {id:child_id,child_name:name,child_sex:sex_id,child_birthday:born,in_grade:class_id,child_pic:child_pic};
    // console.log(JSON.stringify(send_data))
    // window.HostURL = "http://192.168.1.188:94/";
    $api.send("api/resume_sys/edit_child/","post",send_data,function(data){

        if(data.code == 0){
            $api.error(data.error_msg);
        }else{
            $api.tips("保存成功！");

            api.sendEvent({
                name: 'student_record_edit',
                extra: {
                  data:data.data
                }
            });

        }
    },true);
}




function blurInp(object){
    object.style.textAlign = "right";
}
function focusInp(object){
    object.style.textAlign = "left";
}

/* end */
