var DB = function(name){
var mydb = this;
mydb.db_name = name;
mydb.is_connect = false;		
var db = api.require('db');
var ret = db.openDatabaseSync({
    name: mydb.db_name
});

if(ret.status)
mydb.is_connect = true;


mydb.init_db = function(){

/*
db.executeSqlSync({
    name: mydb.db_name,
    sql: 'drop TABLE note'
});

db.executeSqlSync({
    name: mydb.db_name,
    sql: 'drop TABLE session'
});
db.executeSqlSync({
    name: mydb.db_name,
    sql: 'drop TABLE msg'
});
db.executeSqlSync({
    name: mydb.db_name,
    sql: 'drop TABLE relation'
});
db.executeSqlSync({
    name: mydb.db_name,
    sql: 'drop TABLE user'
});
*/
var ret = db.selectSqlSync({
    name: mydb.db_name,
    sql: "SELECT count(*) as count FROM sqlite_master WHERE type='table' AND name='session';"
});
if(ret.data[0].count==0)
{
$api.tips("数据正在初始化...");
db.executeSqlSync({
    name: mydb.db_name,
    sql: 'CREATE TABLE session(id bigint, session_name varchar(200), session_type int, my_user_id int,company_id int, is_group int)'
});
}


ret = db.selectSqlSync({
    name: mydb.db_name,
    sql: "SELECT count(*) as count FROM sqlite_master WHERE type='table' AND name='note';"
});
if(ret.data[0].count==0)
{
$api.tips("数据正在初始化...");
db.executeSqlSync({
    name: mydb.db_name,
    sql: 'CREATE TABLE note(id INTEGER primary key AUTOINCREMENT,company_id int, user_id int,note_type int,in_time bigint,note_content varchar(1000),read_status int)'
});
}

ret = db.selectSqlSync({
    name: mydb.db_name,
    sql: "SELECT count(*) as count FROM sqlite_master WHERE type='table' AND name='msg';"
});
if(ret.data[0].count==0)
{
$api.tips("数据正在初始化...");
db.executeSqlSync({
    name: mydb.db_name,
    sql: 'CREATE TABLE msg(id INTEGER primary key AUTOINCREMENT,session_id bigint,from_user_id int,to_user_id varchar(1000),msg_type int,in_time bigint,msg_content varchar(1000),company_id int,read_status int,block_status int,my_user_id int,v bigint,h bigint)'
});
}

ret = db.selectSqlSync({
    name: mydb.db_name,
    sql: "SELECT count(*) as count FROM sqlite_master WHERE type='table' AND name='user';"
});
if(ret.data[0].count==0)
{
$api.tips("数据正在初始化...");
db.executeSqlSync({
    name: mydb.db_name,
    sql: 'CREATE TABLE user(id int,name varchar(50),note varchar(200),icon varchar(500),local_icon varchar(500))'
});
}

ret = db.selectSqlSync({
    name: mydb.db_name,
    sql: "SELECT count(*) as count FROM sqlite_master WHERE type='table' AND name='relation';"
});
if(ret.data[0].count==0)
{
$api.tips("数据正在初始化...");
db.executeSqlSync({
    name: mydb.db_name,
    sql: 'CREATE TABLE relation(session_id bigint,user_id int,user_role int,in_time bigint,out_time bigint,descn varchar(500),my_user_id int)'
});
}


/*
//var user_id = user_infos.id;
//var company_id = cypy_info.company_id;
var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql:'select * from user'
		    //sql: "SELECT a.id as session_id,session_name,session_type,user_id,descn,name,icon,local_icon from session a left join relation b on a.id=b.session_id and a.my_user_id=b.my_user_id left join user c on b.user_id=c.id where is_group=0 and a.my_user_id="+user_id+" and company_id="+company_id+" and out_time=0"
		      //sql:"select * from relation where session_id in (select id from session where my_user_id="+user_id
		      //+" and is_group=0 and company_id="+company_id+")"
		});
console.log(JSON.stringify(ret.data));

ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql:'select * from relation'
		    //sql: "SELECT a.id as session_id,session_name,session_type,user_id,descn,name,icon,local_icon from session a left join relation b on a.id=b.session_id and a.my_user_id=b.my_user_id left join user c on b.user_id=c.id where is_group=0 and a.my_user_id="+user_id+" and company_id="+company_id+" and out_time=0"
		      //sql:"select * from relation where session_id in (select id from session where my_user_id="+user_id
		      //+" and is_group=0 and company_id="+company_id+")"
		});
console.log(JSON.stringify(ret.data));


var user_list=[];
user_list.push();

var obj = mydb.get_session_byid(1,111);
alert(JSON.stringify(obj));
*/

//console.log(window.devices);




};

mydb.get_group_user_list = function(session_id)
{
	var sql="select user_id,user_role,name,icon,local_icon from relation a left join user b on a.user_id=b.id where out_time=0 and  session_id="+session_id;
	var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: sql
		});
	return ret.data;
}

mydb.get_session_byid = function(session_id,user_id)
{
	var sql="select c.session_name,d.user_id,d.descn,e.name,e.icon,e.local_icon,c.session_type,is_group";
	
	sql+=" from  session c  left join relation d on c.id=d.session_id and c.my_user_id=d.my_user_id left join user e on d.user_id=e.id";
	sql+=" where c.my_user_id="+user_id+" and c.id="+session_id;

	var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: sql
		});
	
    return ret.data.length==0?null:ret.data[0];
};


mydb.get_session=function(session_id,user_id)
{
var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: "SELECT session_name,company_id,is_group,session_type from session WHERE my_user_id="+user_id+" AND id="+session_id
		});
return ret.data;	
};
mydb.get_other_user_list =function(session_id,user_id)
{
var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: "SELECT user_id FROM relation WHERE (my_user_id=0 or my_user_id="+user_id+") AND session_id="+session_id+" and user_id<>"+user_id
		});
return ret.data;
};
mydb.new_session=function(session,user_id)
{
		
		var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: "SELECT count(1) as count FROM session WHERE my_user_id="+user_id+" AND id="+session.session_id+";"
		});
		var sql=""
		if(ret.data[0].count==0)
		sql = "insert into session values ("+session.session_id+",'"+session.session_name+"',"+session.session_type+","+user_id+","+session.company_id+",0)";
		else
		sql = "update session set session_name='"+session.session_name+"',session_type="+session.session_type+" where  my_user_id="+user_id+" AND id="+session.session_id+";";
		
		db.executeSqlSync({
			    name: mydb.db_name,
			    sql:sql
			});
		
		ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: "SELECT count(1) as count FROM relation WHERE my_user_id="+user_id+" AND session_id="+session.session_id+";"
		});
		sql=""
		if(ret.data[0].count==0)
		sql="insert into relation values ("+session.session_id+","+session.user_id+",0,"+session.in_time+","+session.out_time+",'"+session.descn+"',"+user_id+")";
		else
		sql="update relation set out_time="+session.out_time+",descn='"+session.descn+"'  WHERE my_user_id="+user_id+" AND session_id="+session.session_id;
		
		db.executeSqlSync({
			    name: mydb.db_name,
			    sql:sql
			});
};

mydb.new_group=function(group,user_id)
{
		var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: "SELECT count(1) as count FROM session WHERE my_user_id="+user_id+" AND id="+group.session_id+";"
		});
		var sql=""
		if(ret.data[0].count==0)
			sql = "insert into session values ("+group.session_id+",'"+group.session_name+"',"+group.session_type+","+user_id+","+group.company_id+",1)";
		else
		sql = "update session set session_name='"+group.session_name+"',session_type="+group.session_type+" where  my_user_id="+user_id+" AND id="+group.session_id+";";
		
		db.executeSqlSync({
			    name: mydb.db_name,
			    sql:sql
			});
};
mydb.get_user_list_byid = function(user_id_list,user_id)
{
	if(user_id_list.length==0)
	return [];
	var user_id_list_str='';
	for(var i=0;i<user_id_list.length;i++)
	{
	   user_id_list_str+=user_id_list[i];
	   if(i<user_id_list.length-1)
	   user_id_list_str+=',';
	}
	var sql = "SELECT id,name,icon,local_icon,ifnull((select descn from relation where my_user_id="+user_id+" and user_id=a.id),'') descn from user a where id in("+user_id_list_str+")";
	//console.log(sql);
		var ret = db.selectSqlSync({
			    name: mydb.db_name,
			    sql: sql
			});
			
	return ret.data;
};

mydb.get_my_session_book = function(user_id,company_id,kw)
{
	var condition=kw&&kw!=""?" and name like '%"+kw+"%'":"";
	var ret = db.selectSqlSync({
			    name: mydb.db_name,
			    sql: "SELECT a.id as session_id,session_name,session_type,user_id,descn,name,icon,local_icon from session a left join relation b on a.id=b.session_id and a.my_user_id=b.my_user_id left join user c on b.user_id=c.id where is_group=0 and a.my_user_id="+user_id+"  and out_time=0"+condition
			});
			
	return ret.data;
};


mydb.get_his_group_book = function(user_id,company_id,his_id)
{
	var ret = db.selectSqlSync({
			    name: mydb.db_name,
			    sql: "SELECT a.id as session_id,session_name,session_type from session a left join relation b on a.id=b.session_id where is_group=1 and a.my_user_id="+user_id+" and out_time=0 and user_id="+his_id
			});
			
	return ret.data;
};

mydb.get_my_group_book = function(user_id,company_id,kw)
{
	var condition=kw&&kw!=""?" and session_name like '%"+kw+"%'":"";
	var ret = db.selectSqlSync({
			    name: mydb.db_name,
			    sql: "SELECT a.id as session_id,session_name,session_type from session a left join relation b on a.id=b.session_id where is_group=1 and a.my_user_id="+user_id+" and  out_time=0 and user_id="+user_id+condition
			});
			
	return ret.data;
};

mydb.update_my_book = function(user_id,session_list,group_list)
{


	var s1='',s2='';
	for(var i=0;i<session_list.length;i++)
	{
		var session = session_list[i];
		mydb.new_session(session,user_id);

	}

	var res=[];
	for(var i=0;i<group_list.length;i++)
	{
	
	    var group = group_list[i];
		mydb.new_group(group,user_id);
		res.push({session_id:group.session_id+""});
		
		s2 += group_list[i].session_id;
		if(i!=group_list.length-1)
		s2+=",";
	}

	    var ret2 = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: "SELECT id FROM session WHERE my_user_id="+user_id+" AND is_group=1 AND id not in ("+s2+");"
	});
	
	for(var i=0;i<ret2.data.length;i++)
	{
		db.executeSqlSync({name: mydb.db_name,sql: 'delete from session where id='+ret2.data[i].id});
		db.executeSqlSync({name: mydb.db_name,sql: 'delete from relation where session_id='+ret2.data[i].id});
	}
	return res;
};



mydb.update_my_book_session = function(user_id,session_list)
{
	for(var i=0;i<session_list.length;i++)
	{
		var session = session_list[i];
		mydb.new_session(session,user_id);
	}
    return mydb.get_wait_user_list(user_id);
};
mydb.update_my_book_group = function(user_id,group_list)
{
	var res=[];
	for(var i=0;i<group_list.length;i++)
	{
	
	    var group = group_list[i];
		mydb.new_group(group,user_id);
		res.push({session_id:group.session_id+""});
	}

	return res;
};




mydb.update_group_user = function(list,user_id)
{
	    for(var i=0;i<list.length;i++)
	    {
		    var group = list[i];
			mydb.update_group_user_single(group);
	   }

	   return mydb.get_wait_user_list(user_id);

};

mydb.update_group_user_single=function(group)
{
	var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: "SELECT count(1) as count FROM relation WHERE user_id="+group.user_id+" AND session_id="+group.session_id+";"
		});
		sql=""
		if(ret.data[0].count==0)
		{
			sql="insert into relation values ("+group.session_id+","+group.user_id+","+group.user_role+","+group.in_time+","+group.out_time+",'"+group.descn+"',0)";
		}
		else
		sql="update relation set out_time="+group.out_time+"  WHERE user_id="+group.user_id+" AND session_id="+group.session_id;
		
		db.executeSqlSync({
			    name: mydb.db_name,
			    sql:sql
			});

};

mydb.get_wait_user_list = function(user_id)
{
 
 var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: "SELECT user_id FROM relation WHERE (my_user_id="+user_id+" or my_user_id=0) and user_id not in (select id from user)"
		});
		 var user_list=[];
		 for(var i=0;i<ret.data.length;i++)
		 {
		 	user_list.push(ret.data[i].user_id+"");
		 }
		 return user_list;
};

mydb.update_user_base = function(id,name,icon){

//id int,name varchar(50),note varchar(200),icon varchar(500),local_icon varchar(500)

	var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: "SELECT icon,local_icon FROM user WHERE id="+id+";"
		});
		var sql="";
		var old_icon='',local_icon='';
		if(ret.data.length==0)
		sql = "insert into user values ("+id+",'"+name+"','','"+icon+"','')";
		else
		{
		    old_icon = ret.data[0].icon;
		    local_icon = ret.data[0].local_icon;
			sql = "update user set name='"+name+"',icon='"+icon+"' where  id="+id;
		}
		db.executeSqlSync({
			    name: mydb.db_name,
			    sql:sql
			});

	 var ret = {};
	 ret.icon=old_icon;
	 ret.local_icon=local_icon;
	 return ret;
};

mydb.update_user_icon=function(id,local_icon)
{
		db.executeSqlSync({
			    name: mydb.db_name,
			    sql:"update user set local_icon='"+local_icon+"' where  id="+id
			});
};


mydb.get_group_session = function(user_id,company_id)
{
	var sql="select b.id msg_id,session_id,from_user_id,to_user_id,msg_type,b.in_time,msg_content,b.company_id,(select count(1) from  msg where session_id=b.session_id and my_user_id=b.my_user_id and read_status=0) as no_read_count,session_name,c.session_type,e.name,e.icon,e.local_icon,c.session_type,block_status";
	sql+=" from (select max(id) as id from msg where my_user_id="+user_id+"  group by session_id,my_user_id) a left join msg b on a.id=b.id left join session c on b.session_id=c.id and b.my_user_id=c.my_user_id left join user e on b.from_user_id=e.id";
	sql+=" where is_group=1  order by b.in_time desc";

	var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: sql
		});
		
    return ret.data;
};

mydb.get_msg_session = function(user_id,company_id)
{
	var sql="select b.id msg_id,b.session_id,b.msg_type,b.in_time,b.msg_content,b.company_id,(select count(1) from  msg where session_id=b.session_id and my_user_id=b.my_user_id and read_status=0) as no_read_count,c.session_name,d.user_id,d.descn,e.name,e.icon,e.local_icon,c.session_type,block_status";
	
	sql+=" from (select max(id) as id from msg where my_user_id="+user_id+"  group by session_id,my_user_id) a left join msg b on a.id=b.id left join session c on b.session_id=c.id and b.my_user_id=c.my_user_id left join relation d on c.id=d.session_id and c.my_user_id=d.my_user_id left join user e on d.user_id=e.id";
	sql+=" where is_group=0 order by b.in_time desc";

	var ret = db.selectSqlSync({
		    name: mydb.db_name,
		    sql: sql
		});
		
    return ret.data;
};


mydb.get_msg_list = function(session_id,user_id,page,max_id)
{
var size = 30;
var con = max_id>0?" a.id<="+max_id:" 1=1 ";
var sql = "select a.id,a.msg_type,a.msg_content,a.in_time,a.from_user_id,a.to_user_id,b.name,b.icon,b.local_icon,block_status from msg a left join user b on a.from_user_id=b.id where " + con + " and session_id="+session_id+" and my_user_id="+user_id+" order by in_time desc,a.id desc limit " + size + " offset " + size*(page - 1);
var ret = db.selectSqlSync({
    name: mydb.db_name,
    sql: sql
});
return ret.data;
};


mydb.add_msg = function(msg,user_id,read,block){
//console.log(JSON.stringify(msg));
var read_status = read!=null?read:0;
var block_status = block!=null?block:0;

if(msg.v>0)
{
var ds = db.selectSqlSync({
    name: mydb.db_name,
    sql: "SELECT count(1) as count FROM msg WHERE v=" + msg.v + " AND h=" + msg.h + ";"
});
if(ds.data[0].count>0)
return 0;
}

var ret = db.executeSqlSync({
    name: mydb.db_name,
    sql: "insert into msg  values (NULL,"+msg.session_id+","+msg.from_user_id+",'"+msg.to_user_id+"',"+msg.msg_type+","+msg.in_time+",'"+msg.msg_content+"',"+msg.company_id+","+read_status+","+block_status+","+user_id+","+ msg.v +","+ msg.h +")"
});
if(ret.status){
var sql = "select last_insert_rowid() newid;";
var ret2 = db.selectSqlSync({
    name: mydb.db_name,
    sql: sql
});

return ret2.data[0].newid;
}
else
return 0;

};

mydb.upd_msg_block_status=function(id,block_status)
{
var ret = db.executeSqlSync({
    name: mydb.db_name,
    sql: "update msg set block_status="+block_status+" where id="+id
});
return ret.status;
};

mydb.upd_msg_content=function(id,msg_content)
{
var ret = db.executeSqlSync({
    name: mydb.db_name,
    sql: "update msg set msg_content='"+msg_content+"' where id="+id
});
return ret.status;

};

mydb.upd_note_content=function(id,note_content)
{
var ret = db.executeSqlSync({
    name: mydb.db_name,
    sql: "update note set note_content='"+note_content+"' where id="+id
});
return ret.status;

};


mydb.get_msg = function(id)
{
var ret = db.selectSqlSync({
    name: mydb.db_name,
    sql: "select * from msg where id="+id
});
if(ret.data.length>0)
return ret.data[0];
else
return null;
};

mydb.upd_msg_read=function(session_id,user_id,max_id)
{
var ret = db.executeSqlSync({
    name: mydb.db_name,
    sql: "update msg set read_status=1 where read_status=0 and session_id="+session_id+" and my_user_id="+user_id+" and id<="+max_id
});
return ret.status;
};


mydb.get_note_session = function(user_id,company_id)
{
var sql = "select  a.id note_id,session_id,a.note_type,a.user_id,a.company_id,note_content,in_time,(select count(1) from note where note_type=a.note_type and user_id=a.user_id and read_status=0) as no_read_count from (SELECT CAST(user_id as TEXT) || '_' || CAST(company_id as TEXT) || '_' || CAST(note_type as TEXT) as session_id,max(id) as id,note_type,user_id,company_id from note  where user_id=";
	sql+= user_id + "    group by note_type,user_id,company_id) a left join note b on a.id=b.id order by in_time desc";
var ret = db.selectSqlSync({
    name: mydb.db_name,
    sql: sql
});
return ret.data;
};

mydb.get_note_list = function(session_id,page,max_id)
{
var size = 30;
var con = max_id>0?" id<="+max_id:" 1=1 ";
var sql = "select id,note_content,in_time from note where "+con+" and (CAST(user_id as TEXT) || '_' || CAST(company_id as TEXT) || '_' || CAST(note_type as TEXT))='"+session_id+"' order by in_time desc,id desc limit  " + size + " offset " + size*(page - 1);
var ret = db.selectSqlSync({
    name: mydb.db_name,
    sql: sql
});
return ret.data;
};
mydb.add_note = function(note,user_id,read){
var read_status = read!=null?read:0;
var ret = db.executeSqlSync({
    name: mydb.db_name,
    sql: "insert into note  values (NULL,"+note.company_id+","+user_id+","+note.note_type+","+note.in_time+",'"+note.note_content+"',"+read_status+")"
});
return ret.status;
};
mydb.upd_note_read=function(note_type,company_id,user_id,max_id)
{
var ret = db.executeSqlSync({
    name: mydb.db_name,
    sql: "update note set read_status=1 where read_status=0  and user_id="+user_id+" and note_type="+note_type+" and id<="+max_id
});
return ret.status;
};
mydb.del_note_type = function(note_type,company_id,user_id){
$api.showProgress('操作中','请稍后');
db.executeSql({
    name: mydb.db_name,
    sql: "delete from note where user_id="+user_id+"  and note_type="+note_type
}, function(ret, err) {
$api.hideProgress();
    if (ret.status) {
                
    } else {
        $api.tips('操作失败！');
    }
});
};
mydb.del_note_list = function(list,user_id){
if (list.length==0) return;
var id_str='';
for(var i=0;i<list.length;i++)
{
id_str+=list[i]+",";
}
id_str+="0";
$api.showProgress('操作中','请稍后');
db.executeSql({
    name: mydb.db_name,
    sql: "delete from note where user_id="+user_id+" and id in ("+id_str+")"
}, function(ret, err) {
$api.hideProgress();
    if (ret.status) {
                
    } else {
        $api.tips('操作失败！');
    }
});
};



mydb.del_msg_session = function(session_id,user_id){
$api.showProgress('操作中','请稍后');
db.executeSql({
    name: mydb.db_name,
    sql: "delete from msg where my_user_id="+user_id+" and session_id="+session_id
}, function(ret, err) {
$api.hideProgress();
    if (ret.status) {
                
    } else {
        $api.tips('操作失败！');
    }
});
};

mydb.del_msg_list = function(list,user_id){
if (list.length==0) return;
var id_str='';
for(var i=0;i<list.length;i++)
{
id_str+=list[i]+",";
}
id_str+="0";
$api.showProgress('操作中','请稍后');
db.executeSql({
    name: mydb.db_name,
    sql: "delete from msg where my_user_id="+user_id+" and id in ("+id_str+")"
}, function(ret, err) {
$api.hideProgress();
    if (ret.status) {
                
    } else {
        $api.tips('操作失败！');
    }
});
};






		
}
        
        
        
        
        
        
              
       