
window.scroll_subject = null;

var subject = 0;
var subname = "";
var now_grade = 0;

var now_term = 0;

var short_grade = 0;
var short_term = 0;
var short_version = 0;

var now_child_id = 0;

apiready=function(){

  $api.getStatusBar();

  $api.rmStorage("answerList");

  api.addEventListener({
      name: 'viewappear'
  }, function(ret, err){

      $api.close_name("bookdetail");
      api.setScreenOrientation({
        orientation: 'portrait_up'
      });

      var answerData = $api.getStorage("answerList");
      if(answerData != "" && answerData != "undefined"){
          var list = JSON.parse(answerData);
          saveAnswer(list);
      }
  });

  init();

}

function saveAnswer(list){
    $api.send("api/resume_sys/do_answer/","post",{child_id:parseInt(now_child_id),answer_list:JSON.stringify(list)},function(data){
        // console.log(JSON.stringify(data));
        if(data.code == 0){
            $api.error(data.error_msg);
        }else{
            $api.tips("保存成功");
            api.sendEvent({
              name:'upd_home_subject'
            });
        }
        $api.rmStorage("answerList");
    },true);
}

function setStatusBar(){
  $api.byId('book_top').style.top = window.headerPos.h+"px";
  $api.byId('scroll_firms').style.top = (window.headerPos.h+52)+"px";
  var mainH = window.headerPos.h+55;
  $api.byId('scroll_firms').style.height = "calc(100vh - "+mainH+"px)";

  $api.byId('grade_list_box').style.marginTop = window.headerPos.h+"px";
  $api.byId('grade_list_box').style.height = "calc(100vh - "+window.headerPos.h+"px)";
  $api.byId('version_list_box').style.marginTop = window.headerPos.h+"px";
  $api.byId('version_list_box').style.height = "calc(100vh - "+window.headerPos.h+"px)";
  $api.byId('version_list').style.height = "calc(100vh - "+mainH+"px)";
  // version_list

}


if(window.app_type == "WEB"){
  window.onload = function(){
    init();
  }
}


function init(){
    $api.byId("back_page").onclick=function(){
      $api.close();
    }

    setStatusBar();

    var subtype = $api.getPageParam("bookid");
    subname = $api.getPageParam("bookname");
    var grade = $api.getPageParam("grade");
    now_child_id = $api.getPageParam("child_id");

    if(grade != "" && grade != "undefined"){
        now_grade = parseInt(grade);
        short_grade = now_grade;
    }
    if(subname != "" && subname != "undefined"){
        $api.byId("page_title").innerText = subname;
    }
    if(subtype == "" || subtype == "undefined"){
        return;
    }else{
        subject = parseInt(subtype);
        short_version = subject;
    }

    var date = new Date();

    if(date.getMonth() < 2 || date.getMonth() > 8){
      now_term = 1;
    }else{
      now_term = 2;
    }
    short_term = now_term;

    $api.byId("now_grade").innerText = gradeText(now_grade,now_term);

    $api.byId('hide_grade_list').onclick=function(){
        $api.byId('grade_list_wrap').style.display="none";
    };
    $api.byId('switch_grade').onclick=function(){
        $api.byId('grade_list_wrap').style.display="block";
    };
    $api.byId('con_grade_list').onclick=function(){
        now_grade = parseInt(short_grade);
        now_term = parseInt(short_term);
        $api.byId("now_grade").innerText = gradeText(now_grade,now_term);
        $api.byId('grade_list_wrap').style.display="none";
        getPaprList();
    };


    $api.byId('hide_version_list').onclick=function(){
        $api.byId('version_list_wrap').style.display="none";
    };
    $api.byId('switch_version').onclick=function(){
        $api.byId('version_list_wrap').style.display="block";
    };
    $api.byId('con_version_list').onclick=function(){
        subject = parseInt(short_version);
        $api.byId('version_list_wrap').style.display="none";
        getPaprList();
    };


    scrollSub();

    getGradeList();

    setTimeout(function(){
        $api.close_name("bookdetail");
    },1000)

}

// 获取年级的试卷列表
function getPaprList(){
  $api.send("api/resume_sys/get_paper_list/","post",{book_id:subject,term:now_term,grade:now_grade},function(data){
    // console.log(JSON.stringify(data))
      if(data.code == 0){
          $api.error(data.error_msg);
      }else{
          for_paper_list(data.list);
      }
  },true);
}
function for_paper_list(list){

    var paperlistEl = $api.byId("firm_new_list");
    paperlistEl.innerHTML = "";
    for(var i=0;i<list.length;i++){
        var div = document.createElement("DIV");
        div.className = "book_item";
        div.setAttribute("data-id",list[i].id);
        div.setAttribute("data-name",list[i].paper_name);
        div.setAttribute("data-audio",list[i].audio_id);
        div.onclick=function(){
            openBook(this);
        }
        div.innerHTML = '<p>'+list[i].paper_name+'</p>';
        paperlistEl.appendChild(div);
    }
}
function openBook(that){
    var id = that.getAttribute("data-id");
    var name = that.getAttribute("data-name");
    var audioId = that.getAttribute("data-audio");
    var item = {};
    item.id = parseInt(id);
    item.bookid = subject;
    item.bookname = subname;
    item.papername = name;
    item.audio= audioId;

    $api.open("bookdetail","../bookdetail/bookdetail.html",{data:JSON.stringify(item),child_id:now_child_id},false,true);
}

// END 获取年级的试卷列表

// 获取年级列表
function getGradeList(){
  $api.send("api/resume_sys/get_grade_list/","post",{book_id:subject},function(data){
    // console.log(JSON.stringify(data))
      if(data.code == 0){
          $api.error(data.error_msg);
      }else{
          $api.byId('firm_new_list').innerHTML = '';
          for_grade_list(data.list);
      }
      getPaprList();
      setTimeout(function(){
          getSubjectList();
      },1000);
  },false);
}
function for_grade_list(list){

    var gradelistEl = $api.byId("grade_list");
    gradelistEl.innerHTML = "";
    for(var i=0;i<list.length;i++){
        var div = document.createElement("DIV");
        div.id = 'grade'+list[i].grade+'_'+list[i].term;
        div.setAttribute("data-id",list[i].id);
        div.setAttribute("data-grade",list[i].grade);
        div.setAttribute("data-term",list[i].term);
        if(list[i].grade == now_grade && list[i].term == now_term){
            div.className = "sele_grade";
        }
        div.onclick=function(){
            select_grade(this);
        }
        div.innerText = gradeText(list[i].grade,list[i].term);
        gradelistEl.appendChild(div);
    }
}

function select_grade(that){
    if($api.byId("grade"+short_grade+"_"+short_term)){
        $api.byId("grade"+short_grade+"_"+short_term).classList.remove("sele_grade");
    }
    short_grade = that.getAttribute("data-grade");
    short_term = that.getAttribute("data-term");
    that.className = "sele_grade";
}

function gradeText(grade_id,term_id){

  var grade_name = "";
  var grade_type = "";
  switch(grade_id){
    case 1:
        grade_name = "一年级";
    break;
    case 2:
        grade_name = "二年级";
    break;
    case 3:
        grade_name = "三年级";
    break;
    case 4:
        grade_name = "四年级";
    break;
    case 5:
        grade_name = "五年级";
    break;
    case 6:
        grade_name = "六年级";
    break;
  }
  if(term_id == 1){
      grade_type = "上册";
  }else{
      grade_type = "下册";
  }

  return grade_name+grade_type;

}

// END 获取年级列表


function getSubjectList(){
    $api.send("api/resume_sys/get_book_list/","post",{course_id:subject},function(data){
      // console.log(JSON.stringify(data))
        if(data.code == 0){
            $api.error(data.error_msg);
        }else{
            $api.byId('version_list2').innerHTML = '';
            forSubjectList(data.list);
        }
    },false);
}

function forSubjectList(list){
    var listEl = $api.byId('version_list2');
    for(var i=0;i<list.length;i++){
        var el = createSubject(list[i]);
        listEl.appendChild(el);
    }
}

function createSubject(object){
    var div = document.createElement("DIV");
    div.className = "subject_item";
    div.id = "book"+object.id;
    div.setAttribute("data",object.id);
    div.setAttribute("data-name",object.book_name);
    if(subject == object.id){
        div.className = "subject_item sele_book";
    }
    div.onclick=function(){
        switchBook(this);
    }
    div.innerHTML='<div class="subject_item_cover"><img src="'+window.ImgURL+object.book_pic+'" alt=""></div>'+
    '<p class="subject_item_name">'+object.book_name+'</p>';
    return div;
}
function switchBook(that){
    $api.byId("book"+subject).classList.remove("sele_book");
    short_version = that.getAttribute("data");
    that.classList.add("sele_book");
}



function scrollSub(){
  if(window.scroll_subject != null)return;
  window.scroll_subject = new scrollView("scroll_firm",function(ret,err){})
}


//
