


// resume_sys/pay_order/ {company_id  order_paper  pay_type}  back{data:1,session_id:1}

var order_data = {};

var param_data = null;

var pay_type_id = 0;

apiready=function()
{
    // $api.fixedHeader();

    $api.getStatusBar();

    init();

}
function setStatusBar(){
    $api.byId('order_content').style.paddingTop = (window.headerPos.h+10)+"px";

}


if(window.app_type=="WEB")
window.onload = function(){
    init();
}

function init(){
    $api.byId("back_page").onclick=function(){
        $api.close();
    };

    setStatusBar();

    var data = $api.getPageParam("data");
    if(data == "" || data == 'undefined')return;

    // console.log(data)
    param_data = JSON.parse(data);

    set_order_content(param_data);

}

function set_order_content(data){
    $api.byId("order_paper").innerHTML = data.order_paper;
    $api.byId("emplname").innerHTML = data.empl_name;
    $api.byId("order_price").innerHTML = '￥ '+data.price;
    $api.byId("sale_company").innerHTML = data.company_name;
    get_order(parseInt(data.company_id),data.order_paper);
}

function get_order(id,order){
    $api.send("api/resume_sys/get_order_detail/","post",{company_id:id,order_paper:order},function(data){
        // console.log(JSON.stringify(data));
        if(data.code == 0){
            $api.error(data.error_msg);
        }else{
            $api.byId("list_wrap").innerHTML = '';
            order_data = data.data;
            for_student_card(data.data.list);
            check_order_status();
        }
    },true)
}

function for_student_card(list){
    for(var i=0;i<list.length;i++){
        var element = create_student_card_element(list[i]);
        $api.byId("list_wrap").appendChild(element);
    }
}

/* 构造学员卡 列表*/
function create_student_card_element(obj){

    var div = document.createElement("DIV");
    div.id = 'card'+obj.id;
    div.className = 'swiper-slide card_item';


    var elementhtml = '';
    var sklx = obj.card_type==1?"班级授课":"一对一授课";
    var xyklx = obj.course_type==1?"培训类":"托管类";
    var count = '';
    if(obj.total_count > 0){
            count = obj.total_count+"次";
    }else{
            count = '不限次数';
    }
    var invalid = '';
    if(obj.invalid_val == 0  || obj.invalid_val == ''){
            invalid = '长期有限';
    }
    if(obj.invalid_val > 0){
        switch(obj.invalid_type){
            case 1:
                invalid = obj.invalid_val+'天有效';
            break;
            case 2:
                invalid = obj.invalid_val+'月有效';
            break;
            case 3:
                invalid = obj.invalid_val+'年有效';
            break;
        }
    }

    elementhtml += '<p class="card_name">'+obj.card_name+'</p>'+
        '<p class="card_price">￥'+obj.price+'</p>'+
        '<p class="course_name">'+obj.student_name+'</p>'+
        '<p class="course_num">'+count+'</p>'+
        '<p class="card_yx">'+invalid+'</p>'+
        '<p class="list_card_type">'+sklx+'</p>'+
        '<p class="list_course_type">'+xyklx+'</p>';
    div.innerHTML = elementhtml;

    return div;

    // $api.byId('card_list').appendChild(div);

  }

  function check_order_status(){
    var element = document.getElementsByClassName("confirm_btn_box")[0];
    if(order_data.data.order_status == 0){
        $api.byId("confirm_btn").innerHTML = "确认订单";
        element.style.display = "block";
        pay_type_id = order_data.data.pay_type;
        $api.byId("confirm_btn").onclick=function(){
            if(pay_type_id == 0){
                $api.tips("请选择付款方式");
                return;
            }
            confirm_order();
        }
    }else if(order_data.data.order_status == 1){
        $api.byId("confirm_btn").className = "gary_confirm_btn";
        $api.byId("confirm_btn").innerHTML = "订单待确认";
        element.style.display = "block";
    }else{
        $api.byId("confirm_btn").className = "gary_confirm_btn";
        $api.byId("confirm_btn").innerHTML = "订单已完成";
        element.style.display = "block";
    }

    if(order_data.data.pay_type > 0){
        $api.byId('pay_type'+order_data.data.pay_type).classList.add('sel_pay_type');
    }

  }


var send_list = [];
function confirm_order(){
    // window.HostURL = "http://192.168.1.188:94/";
    var send_data = {company_id:parseInt(param_data.company_id),order_paper:param_data.order_paper,pay_type:pay_type_id};
    $api.send("api/resume_sys/pay_order/","post",send_data,function(data){
// console.log(JSON.stringify(data))
        if(data.code == 0){
            $api.error(data.error_msg);
        }else{
            if(data.data.data > 0){
                api.sendEvent({
                    name: 'home_send_msg',
                    extra: {
                        msg_type: 51,
                        msg_content: '',
                        session_id:data.data.data
                    }
                });
                api.sendEvent({
                    name: 'home_update_index'
                });
            }
            send_list = data.data.list;
            if(send_list.length > 0){
              $api.showProgress("发送中");
              setTimeout(function(){
                  api.sendEvent({
                      name: 'home_send_finance',
                      extra: {
                          list:JSON.stringify(send_list),
                          data:param_data.company_id+"&"+JSON.stringify({order_paper:param_data.order_paper,pay_type:pay_type_id,price:param_data.price})
                      }
                  });
                  $api.hideProgress();
              },500);
            }

            order_data.data.order_status = 1;
            $api.byId("confirm_btn").className = "gary_confirm_btn";
            $api.byId("confirm_btn").innerHTML = "订单待确认";

        }
    },true)
}


function sel_pay_type(obj){
    if(order_data.data.order_status > 0)return;
    if(pay_type_id > 0)
    $api.byId('pay_type'+pay_type_id).classList.remove('sel_pay_type');
    obj.classList.add('sel_pay_type');
    pay_type_id = parseInt(obj.getAttribute('data'));
}
