

var student_data = {};
var student_list = [];

var student_now_id = 0;

window.scroll_subject = null;

apiready=function()
{
	// $api.fixedHeader();

	$api.getStatusBar();

	init();
}
function setStatusBar(){
	document.getElementsByClassName("scroll_firm")[0].style.top = window.headerPos.h+"px";
	document.getElementsByClassName("scroll_firm")[0].style.height = "calc(100vh - "+window.headerPos.h+"px)";
}


if(window.app_type=="WEB")
window.onload = function(){
	init();
}

function init(){
  	$api.byId("back_page").onclick = function(){
  		$api.close();
    };

		setStatusBar();

		baseimg[0].imgbase="../../public/images/icon_base_man.png?1";
    baseimg[1].imgbase="../../public/images/icon_base_woman.png?1";

    var data = $api.getPageParam("data");
    if(data == "" || data == "undefined"){
      return false;
    }else{
        student_data = JSON.parse(data);
    }
		var stu_list = $api.getPageParam("stu_list");
		if(stu_list != "" && stu_list != "undefined"){
				student_list = JSON.parse(stu_list);
				for_student_list(student_list);
		}

		$api.byId("switch_student").onclick=function(){
			if(student_list.length > 1){
					open_list_student();
			}else{
				$api.tips("没有其他学员可切换");
			}
		}

		$api.byId('student_list_wrap').onclick=function(e){
				e.stopPropagation();
				this.style.display = "none";
		};

		var dates = new Date();

		var years = dates.getFullYear();
		var months = dates.getMonth()+1;
		var days = dates.getDate();
		var hours = dates.getHours();
		var fen = dates.getMinutes();
		days = days < 10?'0'+days:days;
		hours = hours < 10?'0'+hours:hours;
		fen = fen < 10?'0'+fen:fen;

		$api.byId("now_time").innerText = years+'/'+months+'/'+days+' '+hours+':'+fen;


    set_student_info(student_data);

}


function set_student_info(data){
    var h = $(".student_code").height();
    var w = $(".student_code").width();
		$(".student_code").html('');
    $(".student_code").qrcode({width:w,height:h,text:""+data.student_no});

    var pic = "";
    if(data.student_pic > 0)
      pic = window.HostURL+"api/resume_company/get_student_pic/"+$api.getToken()+"/?company_token="+$api.getCompanyToken()+"&id="+data.student_pic;
    else
      pic = data.student_sex == 1?baseimg[0].imgbase:baseimg[1].imgbase;
    $api.byId("student_pic").setAttribute("src",pic);
    $api.byId("student_name").innerText = data.student_name;


    $api.byId('student_no').innerText = data.student_no;


		student_now_id = data.id;


    get_card_list();
}


/* 获取学员的学员卡列表 */
function get_card_list(ref){
  var show_load = true;
  if(ref)show_load = false;
  $api.send('api/resume_company/get_student_card_list_id/','POST',{student_id:student_now_id},function(data){
    // console.log(JSON.stringify(data))
    if(ref){
      not_hide_refs();
    }
    if(data.code == 0){
      $api.error(data.error_msg);
    }else{
      $api.byId("card_list").innerHTML =  '';
      if(data.list.length > 0){
          set_card_list(data.list);
      }
    }
    is_load_firm = true;
  },show_load);
}
function set_card_list(list){
  for(var i=0;i<list.length;i++){
    set_card(list[i]);
  }
}

/* 构造学员卡 列表*/
function set_card(obj){
  var div = null;
  var add=0;
  if($api.byId('card'+obj.id)){
    div = $api.byId('card'+obj.id);
  }else{
    div = document.createElement("DIV");
    div.id = 'card'+obj.id;
    div.className = 'swiper-slide card_item';
    div.onclick = function(){sel_card(this)}
    add=1;
  }
  if(obj.sale_status == 2){
    div.className = 'swiper-slide card_item no_card_item';
  }else{
    div.className = 'swiper-slide card_item';
  }
    div.setAttribute('data-id',obj.id);
    div.setAttribute('data-cardid',obj.course_card_id);
    div.setAttribute('data-courseid',obj.course_id);
    div.setAttribute('data-coursename',obj.course_name);
    div.setAttribute('data-name',obj.card_name);
    div.setAttribute('data-cardtype',obj.card_type);
    /*div.setAttribute('data-val',obj.invalid_val);
    div.setAttribute('data-valtype',obj.invalid_type);*/
    div.setAttribute('data-coursetype',obj.course_type);
    div.setAttribute('data-count',obj.total_count);/*次数*/
    div.setAttribute('data-leftcount',obj.left_count);/*次数*/
    // div.setAttribute('data-price',obj.price);/*价格*/
    div.setAttribute('data-sale',obj.sale_roy);/*销售提成*/
    div.setAttribute('data-teach',obj.teach_roy);/*老师提成*/
    div.setAttribute('data-status',obj.sale_status);/*停售/在售*/
    div.setAttribute('data-ccid',obj.course_class_id);/*班级id*/
    div.setAttribute('data-end',obj.end_time);/*班级id*/
    var elementhtml = '';
    var sklx = obj.card_type==1?"班级授课":"一对一授课";
    var xyklx = obj.course_type==1?"培训类":"托管类";
    var count = '';
    if(obj.total_count > 0){
      count = obj.left_count+'/'+obj.total_count
    }else{
      count = '不限';
    }
    var yx = '';
    var is_end = false;/*false没过期，true过期*/
    if(obj.end_time == ''){
      yx = '<span>长期</span> 有效';
    }else{
			if(obj.left_count == 0){
				div.className = 'swiper-slide card_item no_card_item';
			}
      var a = obj.end_time.replace("-","/");
      var nowtime = new Date();
      var end_time = new Date(Date.parse(a));
      if(nowtime > end_time){
        yx = "已过期";
				div.className = 'swiper-slide card_item no_card_item';
        is_end = true;
      }else{
        is_end = false;
        yx = '<span>'+obj.end_time.substr(0,10)+'</span> 过期';
      }
    }

    elementhtml += '<p class="card_name">'+obj.card_name+'</p>'+
      '<p class="card_price"></p>'+
      '<p class="course_name">'+obj.course_name+'</p>'+
      '<p class="course_num">'+count+'次</p>'+
      '<p class="card_yx">'+yx+'</p>'+
      '<p class="list_card_type">'+sklx+'</p>'+
      '<p class="list_course_type">'+xyklx+'</p>'+
      '<i id="selcard'+obj.id+'"></i>';
    div.innerHTML = elementhtml;
    if(add==1){
      $api.byId('card_list').appendChild(div);
    }

    scrollFirm();
}
function sel_card(obj){
    var item = {};
    item.stu_id = student_data.id;
    item.id = obj.getAttribute('data-id');
    item.course_card_id = obj.getAttribute('data-cardid');
    item.course_id = obj.getAttribute('data-courseid');
    item.course_name = obj.getAttribute('data-coursename');
    item.card_name = obj.getAttribute('data-name');
    item.card_type = obj.getAttribute('data-cardtype');
    /*item.invalid_val = obj.getAttribute('data-val');
    item.invalid_type = obj.getAttribute('data-valtype');*/
    item.course_type = obj.getAttribute('data-coursetype');
    item.total_count = obj.getAttribute('data-count');/*次数*/
    item.left_count = obj.getAttribute('data-leftcount');/*剩余次数*/
    // item.price = obj.getAttribute('data-price');/*价格*/
    //item.sale_roy = obj.getAttribute('data-sale');/*销售提成*/
    //item.teach_roy = obj.getAttribute('data-teach');/*老师提成*/
    //item.sale_status = obj.getAttribute('data-status');/*停售/在售*/
    item.course_class_id = obj.getAttribute('data-ccid');/*班级id*/
    item.end_time = obj.getAttribute('data-end');/*班级id*/
    $api.open('student_clock',"../student_clock/student_clock.html",{data:JSON.stringify(item)},false,true);
}




/* 学员列表 */

function open_list_student(){
		$api.byId("student_list_wrap").style.display = "block";
}

var student_pic = [];
function for_student_list(list){
		var list_element = $api.byId('student_list');
		for(var i=0;i<list.length;i++){
				var div = document.createElement("DIV");
				div.className = "student_item";
				div.setAttribute("data",JSON.stringify(list[i]).replace(/"/g,"'"));
				div.onclick=function(e){
						e.stopPropagation();
						open_student(this);
				}
				var pic = '';
				if(list[i].student_pic > 0){
						pic = '';
						student_pic.push(list[i].student_pic);
				}else{
						pic = list[i].student_sex==1?baseimg[0].imgbase:baseimg[1].imgbase;
				}
				div.innerHTML = '<div class="student_photo" id=""><img id="student'+list[i].student_pic+'" src="'+pic+'" alt=""></div>'+
				'<p>'+list[i].student_name+'</p>';
				list_element.appendChild(div);
		}
		get_student_pic();
}
function get_student_pic(){
	if(student_pic.length > 0){
			var url = window.HostURL+"api/resume_company/get_student_pic/"+$api.getToken()+"/?company_token="+$api.getCompanyToken()+"&id="+student_pic[0];
			$api.byId("student"+student_pic[0]).onload=function(){
					student_pic.splice(0,1);
					setTimeout(function(){
							get_article_pic();
					},100);
			}
			$api.byId("student"+student_pic[0]).setAttribute("src",url);
	}
}
function open_student(obj){
		var param_data = obj.getAttribute("data").replace(/'/g,"\"");
		set_student_info(JSON.parse(param_data));
		$api.byId("student_list_wrap").style.display = "none";
}
/* END 学员列表 */





/* 时间戳转时间 */
function change_time(tamp){
    var olddate = new Date(parseInt(tamp));
    var old_y = olddate.getFullYear();
    var old_m = olddate.getMonth()+1;
    var old_d = olddate.getDate();
    var old_h = olddate.getHours();
    var old_mi = olddate.getMinutes();
    old_mi = old_mi<10?'0'+old_mi:old_mi;
    if(old_h - 8 <= 0){
        old_d--;
        if(old_d == 0){
          old_m = olddate.getMonth();
          if(old_m == 0){
              old_m = 12;
              old_y--;
          }
          old_d = thisDate = new Date(old_y,old_m,0).getDate();
        }
        old_h = old_h + (24 - 8);
        old_h = old_h<10?'0'+old_h:old_h;
    }else{
        old_h = old_h - 8;
        old_h = old_h<10?'0'+old_h:old_h;
    }
    return old_y+'-'+old_m+'-'+old_d+' '+old_h+':'+old_mi;
}



function scrollFirm(){
  if(window.scroll_subject != null)return;
  window.scroll_subject = new scrollView("scroll_firm",function(ret,err){
		var wrapH = document.getElementsByClassName("scroll_firm")[0].offsetHeight;
		var boxH = document.getElementById("scroll_firm_list").offsetHeight;
		var scrollH = boxH - wrapH;
		if(scrollH > 0){
			if(scrollH - parseInt(ret) <= 1 && scrollH - parseInt(ret) >= -1){
        if(window.is_load_firm){

        }
			}
		}
	},function(ret,err){
    if(window.is_load_firm){
      is_load_firm = false;
      get_card_list("ref");
    }

  })
}
function not_hide_refs(){
  if(window.scroll_subject != null){
			window.scroll_subject.rmrefresh();
	}
}

/*


*/
