
window.scroll_subject = null;

var subject = 0;
var now_grade = 0;
var now_child_id = 0;

apiready=function(){

  $api.getStatusBar();

  init();

}

function setStatusBar(){
  $api.byId('scroll_firms').style.top = window.headerPos.h+"px";
  var mainH = window.headerPos.h+5;
  $api.byId('scroll_firms').style.height = "calc(100vh - "+mainH+"px)";

}


if(window.app_type == "WEB"){
  window.onload = function(){
    init();
  }
}


function init(){
    $api.byId("back_page").onclick=function(){
      $api.close();
    }

    setStatusBar();

    scrollSub();

    var subtype = $api.getPageParam("type");
    var grade = $api.getPageParam("grade");
    now_child_id = $api.getPageParam("child_id");

    if(grade != "" && grade != "undefined"){
        now_grade = grade;
    }

    if(subtype == "" || subtype == "undefined"){
        return;
    }else{
        subject = parseInt(subtype);
    }

    getSubjectList();

}

function getSubjectList(){
    $api.send("api/resume_sys/get_book_list/","post",{course_id:subject},function(data){
      // console.log(JSON.stringify(data))
        if(data.code == 0){
            $api.error(data.error_msg);
        }else{
            $api.byId('firm_new_list').innerHTML = '';
            forSubjectList(data.list);
        }
    },true);
}

function forSubjectList(list){
    var listEl = $api.byId('firm_new_list');
    for(var i=0;i<list.length;i++){
        var el = createSubject(list[i]);
        listEl.appendChild(el);
    }
}

function createSubject(object){
    var div = document.createElement("DIV");
    div.className = "subject_item";
    div.setAttribute("data",object.id);
    div.setAttribute("data-name",object.book_name);
    div.onclick=function(){
        openBook(this);
    }
    div.innerHTML='<div class="subject_item_cover"><img src="'+window.ImgURL+object.book_pic+'" alt=""></div>'+
    '<p class="subject_item_name">'+object.book_name+'</p>';
    return div;
}

function openBook(that){
    var id = that.getAttribute("data");
    var name = that.getAttribute("data-name");
    $api.open("book_list","../book_list/book_list.html",{bookid:id,bookname:name,grade:now_grade,child_id:now_child_id},false,true);
}



function scrollSub(){
  if(window.scroll_subject != null)return;
  window.scroll_subject = new scrollView("scroll_firm",function(ret,err){})
}






//
